commit 5395d18c4bbaa0d9ea96617ad41bd94848fb05e9
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 27 16:42:39 2013 -0700

    wacom 0.23.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit eef947af1447df58099a005834de394edb4b03d0
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Sep 19 17:08:13 2013 -0700

    wacom 0.22.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 6cadaf2eabb91e47963054e1628374861fea6209
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Sep 11 09:55:46 2013 -0700

    Correct return value of special_map_button
    
    The 'special_map_*' functions called by 'parse_actions' are expected
    to return a count of the number of words of input they have consumed.
    The 'special_map_buttom' function errounously returns the number of
    actions added instead, causing the program to potentially skip over
    requested actions which follow a list of "button" actions.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit cde2718ac432f5d745b9ff5ccf6d4f8c2f4fc499
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Sep 11 09:30:37 2013 -0700

    Fix buffer overflows in 'special_map_*'
    
    Each of the 'special_map_*' functions is given free reign to write
    to the end of a buffer, but is never given the size of the buffer
    itself. It is trivial to trigger an overflow simply by feeding the
    program more actions to perform than space to store them.
    
    This patch adds an argument to each function which contains the
    buffer's size. The functions check for sufficient space before
    writing to the buffer and will print out an error message if
    it isn't available.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 59086ba4f5caf4cf6f52f80b5ca36144a882daa5
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Sep 10 16:42:22 2013 -0700

    Add support for Intuos Pro series
    
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cb14924a2a5be21c8525ca70932ab8b5f0f99752
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 4 17:04:13 2013 +1000

    strdup the option key/values in our input_option_new
    
    This is a interface for servers with ABI < 14 (up to server 1.11).
    The server version of it strdups the values, so we must do the same.
    
    Otherwise the values assigned to the InputOption list in
    wcmOptionDupConvert are freed during xf86OptionListFree().
    
    That later causes a SIGABORT when NewInputDeviceRequest starts using
    those options.
    
    https://sourceforge.net/p/linuxwacom/bugs/233/
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 39c4c7fca7db19ac550332fa53d0d4f58a26f67f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sat Aug 31 14:35:58 2013 +1000

    Print list of supported models on wcmPlug
    
    When the driver starts, print the list of supported models. This should
    help with any questions like "does my driver support this or that model".
    
    For those models that don't have a defined name, print "usb:1234:5678"
    instead, so users can at least try to match the usb IDs.
    
    Sample log output:
    [ 25950.166] (II) wacom: Driver for Wacom graphics tablets: PenPartner, PenPartner,
            Graphire, Graphire2 4x5, Graphire2 5x7, Graphire3 4x5, Graphire3 6x8,
            Graphire4 4x5, Graphire4 6x8, BambooFun 4x5, BambooFun 6x8,
            Bamboo1 Medium, Graphire4 6x8 BlueTooth, CTL-460, CTH-461, CTL-660,
            CTL-461/S, Bamboo Touch, CTH-460/K, CTH-461/S, CTH-661/S1, CTH-461/L,
            CTH-661/L, Intuos 4x5, Intuos 6x8, Intuos 9x12, Intuos 12x12,
            Intuos 12x18, PTU600, PL400, PL500, PL600, PL600SX, PL550, PL800,
            PL700, PL510, PL710, DTI520, DTF720, DTF720a, DTF521, DTU1931,
            DTU2231, DTU1631, Intuos2 4x5, Intuos2 6x8, Intuos2 9x12,
            Intuos2 12x12, Intuos2 12x18, Intuos2 6x8 , Volito, PenStation,
            Volito2 4x5, Volito2 2x3, PenPartner2, Bamboo, Bamboo1, Bamboo1 4x6,
            Bamboo1 5x8, Intuos3 4x5, Intuos3 6x8, Intuos3 9x12, Intuos3 12x12,
            Intuos3 12x19, Intuos3 6x11, Intuos3 4x6, Intuos4 4x6, Intuos4 6x9,
            Intuos4 8x13, Intuos4 12x19, Intuos4 WL USB Endpoint,
            Intuos4 WL Bluetooth Endpoint, Intuos5 touch S, Intuos5 touch M,
            Intuos5 touch L, Intuos5 S, Intuos5 M, Cintiq 21UX, Cintiq 20WSX,
            Cintiq 12WX, Cintiq 21UX2, Cintiq 24HD, Cintiq 22HD,
            Cintiq 24HD touch (EMR digitizer), Cintiq 13HD, DTK2241, DTH2242,
            Cintiq 22HDT, TabletPC 0x90, TabletPC 0x93, TabletPC 0x97,
            TabletPC 0x9A, CapPlus  0x9F, TabletPC 0xE2, TabletPC 0xE3,
            TabletPC 0xE5, TabletPC 0xE6, TabletPC 0xEC, TabletPC 0xED,
            TabletPC 0xEF, TabletPC 0x100, TabletPC 0x101, TabletPC 0x10D,
            TabletPC 0x4001, usb:172f:0024, usb:172f:0025, usb:172f:0026,
            usb:172f:0027, usb:172f:0028, usb:172f:0030, usb:172f:0031,
            usb:172f:0032, usb:172f:0033, usb:172f:0034, usb:172f:0035,
            usb:172f:0036, usb:172f:0037, usb:172f:0038, usb:172f:0039,
            usb:172f:0051, usb:172f:0052, usb:172f:0053, usb:172f:0054,
            usb:172f:0055, usb:172f:0056, usb:172f:0057, usb:172f:0058,
            usb:172f:0500, usb:172f:0501, usb:172f:0502, usb:172f:0503,
            usb:1b96:0001, usb:17ef:6004
    [ 25950.167] (II) Using input driver 'wacom' for 'Wacom Intuos4 6x9'
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 3f95c4c58afd25e7c8a3ab18dad936f615cfd189
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Jul 15 10:09:40 2013 -0700

    wacom 0.22.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit b25eb646c36d19a46c561b3c091adb5c86c563df
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jul 12 10:28:08 2013 +1000

    Fix build on ABI < 16 - touch_mask isn't defined
    
    Fixes: http://sourceforge.net/p/linuxwacom/bugs/232
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4982cebdadb32376c3b1964616ede44a712c8a24
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jul 10 11:49:29 2013 -0700

    wacom 0.22.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 67daf21bdb7b32c27818bffaf56849a522d23477
Author: Ping Cheng <pingc@wacom.com>
Date:   Fri Jun 7 15:34:03 2013 -0700

    Unify wcmFingerMultitouch and wcmSendTouchEvent
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit d0a5c68b2582fc6bdcee1d949913f78c0651b1a6
Author: Sjoerd Simons <sjoerd@luon.net>
Date:   Sat May 25 01:06:16 2013 +0200

    Transform touch events just like all other events
    
    Transform touch coordinates in the same way as other events coming from
    the wacom driver otherwise setting for exmaple the Wacom Rotation
    property has no effect
    
    Signed-off-by: Sjoerd Simons <sjoerd@greynoise.nl>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 8e5b56e7a461c416d5b29f338bbd749626452b5d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jul 10 13:50:55 2013 -0700

    Revert "Transform touch events just like all other events"
    
    This reverts commit bfb56bf858e08d95156d52cec9744d3d3251b59c.
    This commit will be split in two to provide proper credit for
    each of the two authors.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 85b62fa528564607875a88babab11dd6d2481b04
Author: Ping Cheng <pingc@wacom.com>
Date:   Tue Jul 2 11:25:59 2013 -0700

    Add support for 0xEC.
    
    It is a Wacom device found in Samsung Ativ Smart PC Pro 700t.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a2c57c0104e2aee3e3f2544b094d443e20f076cb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 3 09:35:30 2013 +1000

    Revert "Add support for 0xED."
    
    Typo in commit message, tablet is actually 0xEC. Revert and re-commit to
    make the patch easier to find.
    
    This reverts commit 8488c2af5bdd6dc4d049dc6d895c50c5f34aea14.

commit 8488c2af5bdd6dc4d049dc6d895c50c5f34aea14
Author: Ping Cheng <pingc@wacom.com>
Date:   Tue Jul 2 11:25:59 2013 -0700

    Add support for 0xED.
    
    It is a Wacom device found in Samsung Ativ Smart PC Pro 700t.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>

commit 361ac83d06159ec02bf33237eb5ec24652c8b700
Author: Ping Cheng <pingc@wacom.com>
Date:   Fri Jun 14 16:03:18 2013 -0700

    wacom 0.21.99.1
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>

commit 4f7d24c2138685a9881c7b5314747dc17d7cc147
Author: Ping Cheng <pingc@wacom.com>
Date:   Fri Jun 14 15:57:16 2013 -0700

    Add xf86OptionListFree for distcheck
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>

commit bfb56bf858e08d95156d52cec9744d3d3251b59c
Author: Ping Cheng <pingc@wacom.com>
Date:   Fri Jun 7 15:34:03 2013 -0700

    Transform touch events just like all other events
    
    Transform touch coordinates in the same way as other events coming from
    the wacom driver otherwise setting for exmaple the Wacom Rotation
    property has no effect
    
    Signed-off-by: Sjoerd Simons <sjoerd@greynoise.nl>
    Acked-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Ping Cheng <pingc@wacom.com>

commit f38dd5736e2df7c3eec0338bd0c7bef8c562b979
Author: Ping Cheng <pingc@wacom.com>
Date:   Thu Jun 6 18:25:52 2013 -0700

    Don't emulate a mouse when multitouch is enabled
    
    Currently when enabling XI 1.2 multitouch events the Wacom driver does a
    strange mix of emulating a mouse (when there is only touch) and
    switches suddenly switches to be a touchscreen when 2 fingers are down.
    
    Change this to only send touch events when using multitouch mode, such
    that the touchscreen works the same as other touchscreens. This enables
    applications to properly respond to one finger touches (e.g. panning
    in GTK+).
    
    The X server core will still send emulated input events to applications
    not supporting multitouch, so there shouldn't be a regression for those
    applications.
    
    Signed-off-by: Sjoerd Simons <sjoerd@greynoise.nl>
    Acked-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Ping Cheng <pingc@wacom.com>

commit 3578b919360e7a4d6cfbbe4c33c3084be0c6d5c9
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Fri May 17 15:11:39 2013 -0700

    Add support for Cintiq 22HDT and 13HD, DTK2241 and DTH2242.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2dffd217b112c346c6c0b07e82cb069a3cf84246
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 13:31:38 2013 +1000

    Don't init abswheel2 valuator (7th val) if we don't have one
    
    InitValuatorAxisStruct() will return if the axisnum > num_axes and not
    initialise anything which is why the current code worked without issues.
    
    With a new patch to the server this will now complain with an error message
    to the log.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit b350a95717ac04a0bed1d836a0b90c94724dc597
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 13:45:15 2013 +1000

    Free the device name after reassigning
    
    When hotplugging the first tool (usually the stylus) changes pInfo->name to
    the name + tool name. Thus, free the original one.
    
    And strdup the oldname so we can unconditially free it, regardless of
    whether we changed the actual device name or not.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 06abd7a61323034bd58e745a18f0b08723de0064
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 13:14:45 2013 +1000

    Free the touch mask on shutdown
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 6d26cb9b9f71bfec1c388a72dcbb09f09f31bd04
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 11:21:40 2013 +1000

    Free input attribute's product
    
    This is copied first by DuplicateInputAttributes, then asprintf makes
    another copy.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit dff311a44c13687c12e86d8233f15bb0f8868361
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 10:55:33 2013 +1000

    Free duplicated option list after conversion to InputOption
    
    The duplicated list is a copy (as the comment in the server says) and thus
    must be freed.
    
    ==27895== 947 (40 direct, 907 indirect) bytes in 1 blocks are definitely lost in loss record 266 of 311
    ==27895==    at 0x4A06B6F: calloc (vg_replace_malloc.c:593)
    ==27895==    by 0x4E538C: addNewOption2 (Flags.c:203)
    ==27895==    by 0x4E5401: xf86addNewOption (Flags.c:216)
    ==27895==    by 0x4AEB24: xf86AddNewOption (xf86Option.c:347)
    ==27895==    by 0x4AE54B: xf86OptionListDuplicate (xf86Option.c:152)
    ==27895==    by 0xB74D139: wcmOptionDupConvert (wcmValidateDevice.c:382)
    ==27895==    by 0xB74D408: wcmQueueHotplug (wcmValidateDevice.c:515)
    ==27895==    by 0xB74D645: wcmHotplugOthers (wcmValidateDevice.c:568)
    ==27895==    by 0xB742DA2: wcmPreInit (wcmConfig.c:599)
    ==27895==    by 0x4C1ACF: xf86NewInputDevice (xf86Xinput.c:846)
    ==27895==    by 0x4C2014: NewInputDeviceRequest (xf86Xinput.c:989)
    ==27895==    by 0x4DD72C: device_added (udev.c:231)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit bc095d579bc6b1380080c83c4e5f6df173364b76
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 9 10:39:39 2013 +1000

    Plug memory leaks left by xf86SetStrOption
    
    xf86SetStrOption() returns a strdup'd string that needs to be freed after
    use.
    
    This requires some const char* → char* changes too, for things that were
    never really const char* to begin with anyway.
    
    wcmEventAutoDevProbe() can use xf86CheckStrOption so it too returns a
    strup that we can free lateron.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 6940e481a4aadfbc4c87362e1461a43b296bc8b1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 30 14:40:07 2013 +1000

    Purge TILT_REQUEST_FLAG
    
    Write-only value, obsolete as of xf86-input-wacom-0.10.4-45-gba90433
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 1329374edbd8bd5a375d32829d0f6153f84e6b6f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 2 09:34:56 2013 +1000

    man: clarify how to configure keys on higher shift levels in xsetwacom
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit d0dbb34e524ebb58bb9a5a623d2fa96a1470516f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 29 14:47:06 2013 +1000

    xsetwacom: map a bunch of special symbols
    
    Punctuation marks and others map to XK_* keysyms but only in their named
    form, not in their single-character symbol form.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit e50725269dd76c4a3c92c84dd4413034a8937df0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 29 14:46:18 2013 +1000

    xsetwacom: if we fail to map a string, try as special key or warn
    
    If a string comes back with a KeySym of 0, try again as a special key. And
    if that fails too, print a warning.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 915a64589f34a0593fe55afa82de30c4415c3020
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 29 14:14:43 2013 +1000

    xsetwacom: add special mappings for Home, End, Delete
    
    These three are likely written as home, end, del, so let's try to
    understand that.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit c1f31c0ab16bc11614d6cfbd9bc16e4714732279
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Apr 29 13:20:58 2013 -0700

    wacom 0.21.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 5c6bd8d45ca2358d42fdd028112e724c691774ba
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Apr 19 18:14:59 2013 -0700

    wacom 0.20.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8d804cdf31bfbf9ec46ee15ab1a58e63f770c2b8
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Apr 18 14:51:37 2013 -0700

    Fix const warnings in wcmSetActionProperty
    
      CC       wcmXCommand.lo
    ../../src/wcmXCommand.c: In function 'wcmSetActionProperty':
    ../../src/wcmXCommand.c:460:23: warning: assignment discards 'const' qualifier from pointer target type [enabled by default]
        case BadMatch: msg = "BadMatch"; break;
                           ^
    ../../src/wcmXCommand.c:461:23: warning: assignment discards 'const' qualifier from pointer target type [enabled by default]
        case BadValue: msg = "BadValue"; break;
                           ^
    ../../src/wcmXCommand.c:462:17: warning: assignment discards 'const' qualifier from pointer target type [enabled by default]
        default: msg = "UNKNOWN"; break;
                     ^
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 135e6f60df1398f2c5145535f68e06703ccd77b4
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Apr 18 14:47:17 2013 -0700

    Remove unused variable
    
    src/wcmUSB.c:451:14: warning: unused variable 'private' [-Wunused-variable]
      wcmUSBData* private = common->private;
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit dfe4d23ef30db20e726605599c1c6bed2aa20a3a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 26 11:39:55 2013 +1000

    Correct comment for Sample and Suppress property
    
    The data in the property is actually the other way round. Oops.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ad952fe2800c875b2f0b4663358d454d793ce57f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Fri Mar 8 17:04:42 2013 -0800

    add support for 0x10d
    
    It is a Wacom device found in Fujitsu Lifebook T902.
    
    Signed-off-by: Stephan Frank <sfrank@cs.tu-berlin.de>
    Acked-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 7a1aadb24b6573809d7324f2549bed749ad1a7f2
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Mar 7 14:11:30 2013 -0800

    Resume button events for pucks
    
    wcmBTNChannel was statically assigned to PAD_CHANNEL by commit 1f9bf45b, which
    excluded button events for CURSOR tools. This patch allows usbParseBTNEvent
    to process button events for both CURSOR and PAD tools.
    
    wcmBTNChannel is removed from wcmUSBData since we do not need it anymore.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit c3b4e869924291ee1ec72a2f02fc1986873efe92
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   Mon Mar 4 18:33:03 2013 +0100

    Make touchscreens (WCM_LCD) direct touch devices
    
    Tested with a tablet pc, allowing finger scrolling in GTK3.
    
    Signed-off-by: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit 9077b12cd6ef7a9772aaea00b52baad64471e4e4
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Mar 5 16:46:27 2013 -0800

    Consolidate calls to wcmEvent into one statement
    
    The extra wcmEvent call was to deal with generic PAD events received
    without motion events in the same packet. Those PAD events would be
    filtered out by the device type retrieving code later.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit db17462c0e85f880647f23a0e8bbfd4d20a38303
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Mar 5 16:45:45 2013 -0800

    Clean up device_type initialization for tool on tablet
    
    usbInitToolType retrieves device type from the kernel when tool
    is on the tablet at X server startup. No need to do it again later.
    
    Since kernel does not have a specific device type for PAD, we have
    to check the actual events to set its type.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 6f9826217f50df8e315d3a7d694a4daf62f32c38
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Mar 5 16:44:52 2013 -0800

    Update MAX_CHANNELS definition
    
    Make room to report pen and touch events simultaneously
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 1bca5eefa22afcce1ebe33812e7d17872ceeafca
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 5 09:41:47 2013 +1000

    Handle DEVICE_ABORT on input ABI 19.1
    
    And do nothing.
    
    USB devices are handled by the kernel, so we don't need to reset the HW.
    ISDV4 devices don't get reset on normal shutdown anyway, so we don't need to
    do anything here either.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ab53739dafee0e0f4a534220501bd067193ff109
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Mar 4 09:46:17 2013 -0800

    wacom 0.20.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 256567c6ad9ec120098d9dbf35e9dc609114bc9d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Feb 26 10:40:53 2013 -0800

    wacom 0.19.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit be0b40d2453ba03d99a6dab460ad4007c4d97161
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Feb 26 09:39:20 2013 -0800

    Fix warning: format expects argument of type
    
    ../src/wcmXCommand.c: In function 'wcmCheckActionProperty':
    ../src/wcmXCommand.c:387:3: warning: format '%d' expects argument of type 'int', but argument 4 has type 'long int' [-Wformat]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit dc5608a2911cf0698db1dd083250e37b4a31d58f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Fri Feb 22 11:14:21 2013 -0800

    Support pen/touch arbitration across product ids
    
    Devices with different product ids for pen and touch, such as
    Cintiq 24HD and DTH 2242, were added recently. Applying arbitration
    only for tools with same product id is not enough.
    
    However, we want to make sure tools with same product id are lined
    properly first. That's why the same routine is repeated instead of
    combined.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 120f72f8f3fe5e74ed87c7ee3828243ba4ba054b
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Feb 21 19:01:25 2013 -0800

    Arbitration applies to puck/Wacom mouse as well
    
    We do not allow finger competes with CURSOR.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 06afd180edad2b39dc717d266f5012ca93bd2d8f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Feb 21 19:01:01 2013 -0800

    Fix pen and touch arbitration
    
    Arbitration did not work as expected since common is meant for tools
    on the same logical port, not for tools of the same physical device
    or of the same product id. Plus, not all devices support touch.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 2ab2dd3d0d2bcd353730f11782aa64bb9dc58b2c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Jan 17 17:42:24 2013 -0800

    Don't reset properties on checkonly
    
    We shouldn't make *any* change to the state if checkonly==true, but
    we've been resetting properties anyway. This blocks off the calls
    to the reset functions to prevent them from being called if it's
    just a drill.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5b9c2d84dfc206ee245ba22b92a6d1d824cff3f0
Author: Ping Cheng <pingc@wacom.com>
Date:   Mon Jan 28 15:59:30 2013 -0800

    Add Touch option to xsetwacom manpage
    
    We did not explicitly add this option when worked on the manpage
    since we thought Gnome control center (g-c-c) or something else
    in userland would take care of touch (as well as its gestures).
    However, I see no sign of getting touch in g-c-c soon. Let's take
    care of touch uers here for now.
    
    Wacom manpage is also updated accordingly.
    
    Reported-by: Nikolai Neff <gefrierbrand@users.sf.net>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>

commit 9a664ab7b99ca68e29f73196c216b3a6918325d5
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jan 23 11:59:37 2013 -0800

    include: Move wacom-util.h after X11 headers
    
    Combined with the "#ifndef" in commit c95c1f2c, this fixes the compiler
    warnings generated about ARRAY_SIZE being redefined.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 352f33964f606370cf2ad6f4edf0800f18c8ed15
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jan 23 11:13:07 2013 -0800

    Have wcmFindActionHandler return success/failure directly
    
    We can guarantee that the out arguments are non-NULL if the property
    was found, so return a boolean instead of relying on the caller to
    check for non-NULL results.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 59925bd45b714376b7f2ba07d0e443ed8db24861
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Jan 17 17:04:38 2013 -0800

    NONE is not a valid action, and NULL a bad value
    
    While the NONE Atom indicates that the driver should reset the
    action at the index it resides it, it is not *itself* a valid
    action. This patch prevents us from attempting to set NONE as
    an action.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5d5be5106183961da2b1e793c4a62e59c1274e01
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Dec 18 12:59:04 2012 -0800

    Have wcmSetActionProperty run checkonly
    
    Instead of checking only the 'actions' property, also check the
    individual 'action' properties as well. We obviously won't be able
    to correctly apply the former if the latter fails midway through.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3f5bc05608d59d08f0ce600afcc9a56acd294ab2
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Dec 17 17:24:43 2012 -0800

    Pass errors from wcmSetActionProperty up the stack
    
    Errors when setting an action property should not be swallowed. Note
    that because the containing function does not bother to call this
    function 'checkonly', clients still can't find out about errors
    until its too late. We'll fix this in the next commit.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ed561f701e4b2ba60fb5d8abf881e816118880a8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 22 14:09:29 2013 +1000

    Setting an invalid action property should return an error
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 33cccd3fa4e5185857b2248b56509a97ed19df84
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Dec 17 16:56:06 2012 -0800

    Have wcmFindActionHandler properly handle wcmFindProp error
    
    If wcmFindProp cannot find the given property, it will return a
    negative error code. At the moment, this is taken as the success
    condition(!?) for the strip_actions case... Aside from being
    wrong, this has the potential to cause some nasty memory corruption.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2d38dac523145e3157a3b5fc200f13254f56219c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Dec 17 16:55:30 2012 -0800

    Improve wcmFindProp readability
    
    The existing code is needlessly hard to follow. It should return
    immediately upon success, and unconditionally bail if it never
    succeeded.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7e418191a29f681331dd0134c8887d641d737410
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Jan 17 16:51:22 2013 -0800

    Increase maximum allowed X11 button number
    
    Actions specify X11 button numbers that should be generated when
    performed. The maximum button number that could be used in an event
    has been raised from the driver-imposed limit (WCM_MAX_BUTTON) to
    the server-imposed limit (WCM_MAX_X11BUTTON).
    
    This feature is necessary for gnome-settings-daemon to work properly.
    To reliably identify each touch strip and ring, g-s-d assigns each
    a high button numbers to send for each direction. Without this
    patch, the driver ignores the actions set by g-s-d and continues
    to send whatever the default action is instead.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 082f37feee3170521df4a1a1bbd91e0274282bf1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Dec 18 12:58:45 2012 -0800

    Improve logging of X property setting
    
    Sprinkles a few extra DBG() calls into the code to make it a little
    easier to track down issues with property-setting code.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b6bd20a660f6c682f9de3372b3f1a636a34d9b65
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 18 08:43:52 2013 +1000

    test: replace INCLUDES with AM_CPPFLAGS
    
    see https://lists.gnu.org/archive/html/automake/2012-12/msg00038.html
    
    - Support for the long-deprecated INCLUDES variable will be
      removed altogether in Automake 1.14.  The AM_CPPFLAGS variable should be
      used instead.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 4cffb337d7dc43d17e11a28f70a8be11f21d74ff
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 10 11:30:15 2013 +1000

    Fix a debug message not parsed by sigsafe printf code
    
    The server doesn't interpret %g, use %f instead. tbh, right now it doesn't
    interpret %f either, but there's patches on the way for that.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit b7a2d8e7eb57fb11ec7753d555ab479475fe5230
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 10 11:25:07 2013 +1000

    Drop unused maxWidth/maxHeight
    
    These two are never set to anything but 0 since
    xf86-input-wacom-0.10.10-19-g6f5f29b
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit a7de9daa67afbf0c721e681809be2fbe519d26c8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 19 12:37:03 2012 +1000

    Fix indentation in usbStart()
    
    No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c95c1f2c2d449f78eae109b927db85db05ab9a6f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 20 13:21:37 2012 +1000

    include: don't redefine ARRAY_SIZE
    
    The server provides this macro in its headers, so only redefine it where
    needed (for the tools)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit bc2de318b5ad131fb60d3c5a057c185f764969a1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jan 2 11:15:53 2013 -0800

    wacom 0.19.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit c29dbba29eb6e8ab1494339c29483b0e1068d894
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Dec 20 17:21:29 2012 -0800

    Properly map 2nd abswheel of Cintiq 24HD touch
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 654fdcb188e272f4122ea128612e899b397b0709
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Dec 19 11:15:21 2012 -0800

    wacom 0.18.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit d4aad5dd0c0d010701e2d3f46d9cd98daf6883e4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 19 13:43:09 2012 +1000

    If ds.device_type is 0, set it to the one we guessed earlier
    
    priv->wcmDeviceType contains the guessed device type, after querying the key
    state from the kernel. If that found our device type, use it.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit 7e86e9871459c980a95bcea98dd0a2890b0b584a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 19 13:43:08 2012 +1000

    Fix missing braces around condition in refreshDeviceType
    
    Causing this function to always return 0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit 5209f14707c7d1446c0987adba74cb46028dbf3c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 19 13:43:07 2012 +1000

    Handle BTN_TOOL_MOUSE/LENS in toolTypeToDeviceType
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit 37734d52cc1ce84ba5153bb45587892b5070c9c5
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Dec 18 14:48:20 2012 -0800

    Filter out DOUBLETAP and TRIPLETAP events for true MT data
    
    DOUBLETAP and TRIPLETAP are duplicated events in type-B MT format.
    We do not use them in this driver. Plus, they could be confused
    by fake MT events on older kernels.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>

commit 1f9bf45bdf2eb58491fa578aa6b9ce55a9c13366
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Dec 18 14:47:53 2012 -0800

    Assign PAD_CHANNEL to BTNChannel for all PAD tools
    
    BTNChannel is static for all devices, not just geneic devices.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 62e5222c14cb4d282a3a285e7dd84f0ea1d00e36
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Dec 13 12:19:23 2012 -0800

    BTN_TOOL_FINGER is not for PAD if MT is supported
    
    BTN_TOOL_FINGER indicates single touch/first finger if MT is enabled
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit b5bcd03d12773e3147b4eb5d6a2a39b4c06bb9f4
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Dec 13 12:18:37 2012 -0800

    Send generic PAD events before other events
    
    If we wait until we finish other verifications, we could miss
    PAD events since they will be filtered out when there are no
    motion events sent simultaneously.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 6bd777a7d15c071dc2079fb8bcb4a7f13685aeba
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Dec 13 12:18:02 2012 -0800

    Initialize wcmBTNChannel in usbWcmInitPadState()
    
    wcmBTNChannel is only used by generic PAD device.
    And it is statically assigned to PAD_CHANNEL. No
    need to reassign it for every packet.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit f310e20f6a3dc519f7d318ee53c1024f28892991
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Dec 13 12:16:52 2012 -0800

    Remove channel duplication code for generic devices
    
    We use true MT protocol for MT devices in kernel now. This code
    was introduced to deal with ABS_TOOL_*TAP events loss issue. It
    is uncessary any more. And its existence makes it hard to support
    generic PAD cleanly.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 5d0f8c1abea4b1a791d169ffb15a0b2aee50a7d3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 10 15:35:38 2012 +1000

    man: CursorProx affects absolute mode as well
    
    Update man-page for driver behavior.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit f3ede09dd504e2ca054bbac7413bd9a3416ec31f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Dec 4 14:51:32 2012 -0800

    Convert resolution from points/inch to points/m
    
    Somehow we forgot Lenovo W700 last round.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2b285d01e1c03b51a8526516acda208edbeeac89
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Dec 4 14:51:05 2012 -0800

    Update resoltuion for old kernels
    
    We upscaled resolutions in WacomModelDesc and reported from
    absinfos. But we forgot to update them for older kernels
    that do not support resolution in absinfo.
    
    Resolution received from kernel is in hundredths of a mm.
    The scale we use here is in meter.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a82f0251e400b98b0044f2c8ab89c4b61ec99d4f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Dec 4 14:50:42 2012 -0800

    Post maximum number of contacts to clients
    
    Clients should know the maximum number of contacts a touch device
    support before they get touch events.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 26a6a42fd0a726518f62b8da6926b111a01b33cf
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Nov 14 09:54:34 2012 -0800

    Properly clear action properties
    
    What we want to do is clear all 256 steps of an individual action. What
    we were doing was clearing just the first step.
    
    As mentioned on the ArchWiki, this cuases the following behavior:
      $ xsetwacom --set <id> Button 1 "key a b c" # press button 1 -> abc
      $ xsetwacom --set <id> Button 1 "key d"     # press button 1 -> dbc  WRONG!
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5899942e84d4ae7498ea0cc764aa05b609738d7f
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Nov 21 12:14:10 2012 -0800

    Add support for MT ISDv4 device 0x4001
    
    It supports up to 10 fingers
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 38018e941ff197d00867feff4fe7fb501f584826
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Nov 21 12:13:44 2012 -0800

    Support up to 16 touch points
    
    Bamboo3 and Intuos5 both support 16 fingers
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4ba50c66d65d11232e169d3202ea4a34e06362de
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 21 16:12:48 2012 +1000

    Bring back AM_MAINTAINER_MODE, default to enabled
    
    See Ron's comments discussion on:
    http://old.nabble.com/-PATCH-libwacom--Drop-AM_MAINTAINER_MODE-td34561358.html
    
    Summary:
    In this workflow all generated files are committed to git to have a known
    working set. On checkout, git does not restore the original timestamps,
    so with maintainer-mode enabled, automake will regenerate the files - which
    is to be avoided since we already have the known working set.
    
    AM_MAINTAINER_MODE([enable]) gives us the same behaviour as now, but will
    allow Ron to disable the regeneration of the files.
    
    Requested-by: Ron <ron@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 0c417e33d5b45ce9206448fb45de9338c25c1f5d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Nov 5 09:10:27 2012 -0800

    Don't declare touch_mask on older servers
    
    Missed necessary preprocessor guard in 0d164e66.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3474d206359cf54e991d5dfeff04ed00efa3ce4e
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Oct 26 16:01:47 2012 -0700

    wacom 0.18.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit b3e52e3f921a8f28962ec6e369db1235f046168c
Author: Ping Cheng <pingc@wacom.com>
Date:   Thu Oct 25 17:47:24 2012 -0700

    Add three MT ISDv4 devices (E5, 100, 101)
    
    Signed-off-by: <pinglinux@gmail.com>

commit 97358d0effeb4b72af095cb67d12881286f6fb04
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Oct 23 10:20:17 2012 -0700

    Have direct-touch devices move into and out of GESTURE_DRAG_MODE
    
    Direct-touch devices (e.g. tablet PC, 24HD touch) are currently left in
    GESTURE_NONE_MODE while performing drags. This can lead to potential
    "stuck button" issues, since as soon as a second finger comes in
    contact, the driver will switch to GESTURE_LAG_MODE. This prevents the
    wcmSingleFingerPress function from being called, leaving button 1 in a
    pressed state. While any subsuquent gesture will release button 1, if
    the pen is brought into proximity before one occurs, the fingers will be
    sent out of proximity without a chance to release button 1. This causes
    the button to remain "stuck" in the pressed state until the next touch
    occurs.
    
    There are a few different ways this issue could be addressed. In the
    interest of symmetry with indirect-touch devices, this patch has
    direct-touch devices enter and exit GESTURE_DRAG_MODE as well. This
    delays the mode swith to GESTURE_LAG_MODE by one event, allowing
    wcmSingleFingerPress to be called to release button 1.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=56308
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 74396082c690800a04d20dab2c41e873836774aa
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 24 17:13:25 2012 +1000

    If _source is NULL, don't auto-pick the type.
    
    An xorg.conf InputDevice section that does not have Option Type set is
    invalid. Skip the type assignment and return, triggering an error about an
    invalid type lateron.
    
    Fixes crash triggered as of xf86-input-wacom-0.17.0-8-g0debde6 by having an
    InputDevice section like this:
    
    Section "InputDevice"
        Identifier "--device--"
        Driver "wacom"
        Option "CorePointer" "on"
    EndSection
    
    This would lead to the device being assigned a type and assumed to be for
    hotplugging. Later, when the device attributes are duplicated during
    QueueHotplug, asprintf() tries to duplicate attr->product, which is always
    NULL for xorg.conf devices.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 9f896f4800593c7fa232e40fd934b7f51d0dde6d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Oct 19 17:15:58 2012 -0700

    wacom 0.17.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8b412136a4bd032534bd0eb970a4a06c942fcf59
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Oct 19 17:13:13 2012 -0700

    Limit use of touch class to touch devices only
    
    Applying the touch class to all devices shouldn't really affect
    anything, but just to be sure we surround it in a IsTouch() check.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 637651338015563c6847028870aaa08b293f1ef1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Oct 18 13:06:36 2012 -0700

    Correct number of actions reported by sendWheelStripEvent to sendAction
    
    Commit 477a261e has sendWheelStripEvent use the ARRAY_SIZE macro on a
    pointer. This will not return a proper value, causing the wrong array
    length to be provided to sendAction. This can lead to only the first few
    actions assigned to a wheel or strip actually being performed.
    
    This patch changes the signature of sendWheelStripEvent to accept an
    explicit length.
    
    https://sourceforge.net/tracker/?func=detail&aid=3577713&group_id=69596&atid=52$
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit e81c1400b023be49afc3f62066d21281a1c2bb95
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Oct 18 12:52:15 2012 -0700

    Have getWheelButton deal with array indices instead of pointers
    
    This patch modifies the function signature of getWheelButton so that it
    accepts and returns array indices rather than pointers. This is in
    preparation of the next commit, which would be needlessly unreadable
    otherwise.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit cc855c1c4f1815c691fbef2293d04b78f28ffc42
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Oct 17 18:02:56 2012 -0700

    Restore pad button functionality
    
    Commit b0083492 broke pad buttons by no longer setting the wcmBTNChannel.
    With this variable left uninitialized, pad button data would be stored
    in another channel (e.g. 0) without any other data like proximity set.
    
    This commit sets wcmBTNChannel to point to the channel used for
    storing pad data whenever a pad packet is detected.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Acked-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7c91665c86c93b9668a1649d20b32550fbdc544b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Aug 2 09:23:55 2012 -0700

    Add support for Cintiq 24HD touch
    
    Adds support for the EMR and touch digitizers on the Cintiq 24HD
    touch. The digitizers are on separate USB devices, which can lead to
    the cursor jumping back and forth between the stylus and finger.
    Performing arbitration between the two (disabling finger while pen is in
    proximity) is expected to be handled by the kernel driver.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8c17d224a5df855ccdb1bb15862156782532074c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Oct 8 11:03:18 2012 -0700

    Add recently-referenced functions to fake-symbols
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c85ecf117d4937b6943b5a1215711c99389e5c46
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 17 08:25:19 2012 +1000

    Drop AM_MAINTAINER_MODE
    
    We want xf86-input-wacom to react to changes in Makefile.am's
    
    Long writeup:
    http://blogs.gnome.org/desrt/2011/09/08/am_maintainer_mode-is-not-cool/
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 72508ebe5533501758aad073f120b50f04ac0060
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Oct 2 14:29:24 2012 -0700

    Fix prerequisite check in wcmUpdateSerial
    
    The prerequisite check in wcmUpdateSerial is incorrect. If the tool ID
    changes, the property reflecting it will not be updated unless/until the
    serial number also changes. The check is updated to reflect this.
    
    Additionally, the prerequesite check at one of its callsites is removed
    since the function performs the same check internally.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=45237
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Ping Cheng <pingc@wacom.com>

commit 3e9be03fe19db693f600844b24ce66cefcf6267a
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 21 19:57:00 2012 -0700

    Move check for enabled gestures to the functions that execute them
    
    At the moment, disabling gestures disables *all* gestures. That includes
    the core "tap to click" gesture (and slightly-less-core "tap and hold to
    drag"). This patch allows these two gestures to not be considered such
    by moving wcmGesture check into the functions that execute the gesture.
    All two-finger functions (right click, scroll, and zoom) are disabled by
    wcmGesture, but all single-finger functions remain operational.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit 0d164e66cbb7119d68d2008242f0ec2cca2202a7
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Sep 26 10:57:27 2012 -0700

    Use new multitouch protocol in XI2 if possible
    
    Adds a new MULTITOUCH gesture mode that will redirect all in-contact
    touches through the new multitouch code available in XI2.2 (ABI >= 16).
    
    MULTITOUCH mode will only be entered when in-driver gestures have been
    disabled and at least two fingers are present. The driver will remain
    in this mode until *all* fingers have left the tablet.
    
    For the moment, all touches are sent as XIDependentTouch. Direct touch
    devices such as tablet PCs and Cintiqs are not an exception. This may
    be changed in the future once frameworks are better equipped to handle
    direct input touches.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit a6f1e4b10524cba3272147537cef036e860cac4c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Sep 18 16:06:55 2012 -0700

    Dynamically choose channel for ABS_MT data
    
    Now that the touch code doesn't look in statically-defined
    channels and usbChooseChannel is capable of locating channel
    numbers for arbitrary tool type/serial combinations, we can
    use the latter to track an aribrary number of touches without
    fear of stepping on the toes of another channel.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit f85f025b4ad08295222a1264b4d2cfb20ccdb918
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 21 13:56:21 2012 -0700

    Have usbChooseChannel take explicit device type and serial args
    
    Instead of divining this information from the stored private data,
    take them as arguments. This gives us more flexibility in finding
    channels for sub-tools (e.g. individual fingers).
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit b00834928e81ca2ddaaf00c78a2ea1a4ac50b19c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Jun 25 17:32:43 2012 -0700

    Simplify usbChooseChannel logic
    
    Instead of having different per-protocol cases, just obtain serial
    numbers equivelent to those you'd get from Protocol 5 and then
    use that serial to find a channel dynamically.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit afb25836e6350b5aaea76ccc68b2e16d382e1398
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Aug 1 17:10:27 2012 -0700

    Make usbInitToolType more generic, and always use
    
    Tweaks the usbInitToolType function to be always useful. This is
    needed so that we can use it to get the tool type for all event
    frames, allowing us to properly fill in the tool type for devices
    that we otherwise don't figure out until later on (which causes
    problems with the proper operation of usbChooseChannel).
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit 63cf3c5a2a04559838ec6fd6b9e7e808818072b1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 21 19:07:57 2012 -0700

    Dynamically find touch channels, instead of hard-coding
    
    Right now the driver assumes that the first touch will always
    be in channel 0, and the second touch (if present) is in
    channel 1. This patch adds a new function to scan the channel
    list for appropriate contacts, and uses it instead of the
    hard-coded index accesses.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit 709e0aa23f34003d4526cbf9435a295ee83e0ee0
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 21 19:13:45 2012 -0700

    Use serial number instead of channel number to identify contacts
    
    Code that deals with touch points shouldn't care which channel an
    event is occuring in; it should be more concerned with the finger
    that caused it. At the moment these are the same things (first
    finger is always in channel zero), but this will soon change.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit 67822ebb90a89f5d95ed45a316d905a10c87fc53
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Sep 18 16:24:22 2012 -0700

    Add and use a 'dirty' bit for WacomChannel
    
    Instead of keeping around 'channel_changed', 'mt_channel_changed',
    and 'btn_channel_changed', just add a flag to the WacomChannel
    itself that can be set whenever something changes.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Tested-by: Chris Bagwell <chris@cnpbagwell.com>

commit 0debde6b14a1765e1dd5a483faafe6b90e0e62ba
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Sep 24 16:30:05 2012 -0700

    Properly handle nulls in wcmIsHotpluggedDevice
    
    Commit def7b5fd changed how wcmIsHotpluggedDevice handles null values,
    with the result that a device with no "_source" specified would be
    interpreted as having been hotplugged. This restores the original
    behavior.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1b4da8527d2719cc9ab1f5ed1390ffac44772230
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Sep 24 16:12:29 2012 -0700

    Properly handle nulls in wcmCheckSource
    
    Commit cff344b1 modified the null-handling of wcmCheckSource, such
    that the wrong result will be returned if either/both  fsource and
    psource are null. This patch restores the original behavior.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0a27c707eafe57a85266452a395f89c8237efdbf
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Sep 24 17:53:49 2012 -0700

    Fix double-free in wcmPreInitParseOptions
    
    The 'tool' function here is set equal to 'priv->tool' earlier in
    this function. If an error condition occurs, the tool can be freed
    both here and in wcmFree (via wcmUninit).
    
    It should be safe to postpone this free() until wcmFree to be
    freed along with the rest of the memory allocated in wcmAllocate.
    There should be no leak (wcmUninit will be called on failure) and
    any code relying on priv->tool being a valid pointer after the
    failure of wcmPreInitParseOptions is already broken.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=55200
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 59941213fb8972abc1cd3bf3762444ab73ae1329
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jun 27 10:28:53 2012 -0700

    Device grab should be optional
    
    Like in recent versions of xf86-input-evdev, grabbing the input device
    with EVIOCGRAB should be optional. This would enable for example
    indicator applets, and would improve dynamic handling of different input
    devices.
    
    Proposed patch extended to document new GrabDevice driver option.
    
    https://sourceforge.net/tracker/?func=detail&aid=3509828&group_id=69596&atid=525124
    
    Reported-by: henris42

commit 0fe7f800295a4b5bf074bca798cf8024fcb174ec
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Sep 13 16:59:01 2012 -0700

    Ignore out-of-prox events from unknown devices already out-of-prox
    
    Fixes an issue with the Intuos5, which sends extra out-of-prox
    notifications when the ExpressKeys are touched. This causes the driver
    to ask the kernel for the tool currently in prox and post an empty event
    for it. The result is a cursor that (only while the pen is in prox)
    sometimes jumps to the top left when touching the buttons.
    
    We fix this by ignoring events that claim to be leaving prox when the
    tool is already supposedly out of prox.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=54250
    
    Reported-by: Timo Aaltonen <tjaalton@ubuntu.com>
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit e604e4e6c69898920e27aeed5a772484d796562b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 7 12:24:23 2012 -0700

    Have keysym_to_keycode handle unused keycodes
    
    The current implementation of keysym_to_keycode does not
    properly handle unused keycodes. The functions XkbKeySymsPtr
    and XkbKeyGroupWidth mislead it into believing it is reading
    a keysym associated with the unused keycode when in reality
    it is reading a keysym associated with the *next used*
    keycode.
    
    This impacts different keys depending on the keyboard layout
    in use. On mine for instance, the left Super key is unusable
    because its keycode is preceeded by an unused keycode.
    
    To resolve this issue, we take a page from XKeysymToKeycode
    and use the function XKeycodeToKeysym instead of manually
    accessing the keysyms.
    
    https://sourceforge.net/tracker/?func=detail&aid=3555424&group_id=69596&atid=525124
    
    Reported-by: alexmaret
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit cea5cc1f25c3a1d9f1feec88b0c4d8af59b47a74
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Sep 6 09:41:26 2012 -0700

    Add LogMessageVerbSigSafe to fake-symbols
    
    Somehow overlooked this while adding 'xf86MsgVerb' to fake-symbols.
    Oops.
    
    Reported-by: Timo Aaltonen <tjaalton@ubuntu.com>
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 2f2acecb97e1ac941e85ddbb704e3ce7f37d0261
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Tue Aug 28 23:17:28 2012 +0300

    Use kernel-reported tilt range and resolution
    
    Use tilt range and, optionally, resolution reported by the kernel for event
    devices.
    
    Add a constant for resolution currently expected by applications: TILT_RES,
    1 point per degree in kernel units (points/radian). Scale values to this
    resolution for compatibility and specify it for corresponding valuators
    (instead of 1) for future use by applications.
    
    Add constants for currently reported value limits: TILT_MIN and TILT_MAX,
    -64 and 63 respectively. Continue clamping values to [TILT_MIN, TILT_MAX]
    for compatibility.
    
    Values and ranges reported by currently supported tablets should remain
    unchanged.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit c246b7e4f756856d0d32501f86c7d655efe97106
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Sep 5 09:22:26 2012 -0700

    wacom 0.17.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit e918c957f1c77fda3dec3fb9cb38ded6ffed9ca4
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Aug 27 09:42:37 2012 -0700

    wacom 0.16.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 03583c5a54292cd484d41656e141e3c65ed961da
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Aug 27 10:28:54 2012 -0700

    Add xf86MsgVerb to fake-symbols to let 'make distcheck' complete
    
    The switch from 'xf86Msg' to 'xf86MsgVerb' introduced in commit
    e4c1af41 requires that we define the latter in our fake-symbols
    so that the test suite can compile correctly.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 625a43c040fd71393be94fdfad6cf7faa49db775
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Aug 22 15:05:48 2012 -0700

    Make test_get_wheel_button happy
    
    Apparently there is some subtle difference here between returning
    a pointer and using a double-pointer as an output parameter.
    Tracing through the function shows the former *should* be working,
    but for an unknown reason fails "assert(action == &action_dn)"...
    
    This patch shouldn't change any functionality -- it just shuts up
    `make distcheck`.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit d8613ffc961be4c957ed30d4ac03e83411f835b6
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Aug 22 11:30:14 2012 -0700

    Update test to match new function signature
    
    The getWheelButton function's signature was changed in commit 40ecdcb5
    but the tests were not updated to reflect this.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit ac17300d842f2842eff3a2b2aa3dbac7ebf88a2b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 23 09:03:34 2012 +1000

    Pre-allocate the tap timer
    
    wcmSingleFingerTap() is called during SIGIO, calling TimerSet(NULL, ...)
    will malloc inside the signal handler and hang the box.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit b5a6983c62d233cfc7174f8f48e3abf3064c04ce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 20 12:14:28 2012 +1000

    Log debug messages in signal-safe manner
    
    This is a rather broad brush, logging all messages in DBG() through the
    signal-safe interface instead of just the ones that really need it.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 90cdf85ca3a3d08f79bf6928cd11edaf08b81786
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue May 29 16:51:00 2012 +1000

    Use signal-safe logging patches where necessary
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 58d2a675b616af9e575f0bc0dcec7950a5498c9d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Jul 10 09:29:01 2012 -0700

    Set WCM_LCD on the Cintiq 24HD
    
    This flag was apparently forgotten when the 24HD was originally
    added.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8dcf5ee466cfb14490fa52c8af8a4cbac92036f7
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jul 25 17:39:49 2012 -0700

    Add missing newline to error message
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit b620267a709cb399338641fcc4c671aad2c7986c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jul 25 12:18:17 2012 -0700

    Internally use physical button numbering for actions
    
    One should not have to keep in mind the historic quirk that
    mouse buttons 4-7 have when dealing with buttons events generated
    by the tablet. This patch isolates conversion between physical
    and X11 numbering to the single place it has historically
    mattered: the button property getters/setters.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 40ecdcb59952cea69a2b520c34e21922fbaa2c62
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Feb 27 10:38:52 2012 -0800

    Remove raw button fallback codepaths from wcmCommon
    
    With actions now defined on initialization and reset to default
    when given a 'None' action, we can remove the raw button codepaths
    without a noticible change in driver behavior.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 089a397e5a32aa2e8e212a2c908c7ac782f2b398
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Apr 2 17:05:43 2012 -0700

    Reset-on-None for Actions property
    
    This patch adds the ability to reset an individual Action by
    setting the corresponding element of an Actions property to
    the 'None' atom (i.e. 0). When encountered, the None will be
    replaced with an atom representing the default Action. This
    will let the driver behave as it currently does once raw
    button support is removed.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8c1f585446f56303058840fc40c133c0bab9cc7c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 3 10:10:59 2012 -0700

    Initialize action properties from defaults
    
    This patch adds functions capable of resetting the action
    properties (button/stip/wheel) to their default, and calls
    them on initialization.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8c6711b14b105770e792e6de08cd1e05ddd07ba5
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 3 10:09:32 2012 -0700

    Cleanup call chain for action properties
    
    This patch rewrites the call chains used for setting the three
    action properties by introducing a single function to handle
    the 'Actions' properties, and a single function for 'Action'
    properties. Functions which were merely helper functions have
    been inlined if appropriate.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 29be2391f3f07b04103a2146bece728421aa41e3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Feb 6 12:42:04 2012 -0800

    Remove support for 8-bit (raw button) strip/ring properties
    
    This patch removes the ability to set up the touchstrips or
    touchrings with raw 8-bit button numbers. Buttons have been
    without this ability for quite some time, and this brings
    these two properties in line.
    
    This patch will break applications which rely on the use
    of raw buttons in the properties, but the actual fallout is
    expected to be minimal. Applications which don't understand
    Actions are already broken (since they can't work with buttons)
    and those that do understand Actions but don't use them can
    be easily modified.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 0512c1add914e090feaaa55586b32be84a0cdd8c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Feb 10 12:06:47 2012 -0800

    Replace multiple default variables with arrays
    
    Storing the defaults for strips and wheels in individual
    variables makes updating and scanning through them very
    tedious. This patch replaces the variables with arrays
    and introduces new #define statements to keep the level
    of semantic meaning we had.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 0233668825401bda5473945ad7277c0bf9f89958
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Feb 10 11:29:45 2012 -0800

    Directly index into the various *keys arrays
    
    The 'keys' array is indexed into by reference to the X11 button
    number stored in the 'buttons' array. While this may have been
    useful at some point in time, the benefits have since gone and
    left behind nothing but headaches.
    
    Note that because the association with X11 buttons has been
    removed, action mapping (via xsetwacom) no longer depends on
    on the raw mapping (via xorg.conf). For instance, on a system
    which has 'Option "Button3" "1"' set, use of the command
    'xsetwacom set <id> button 1 10' will no longer cause *both*
    button 1 and button 3 to emit button 10. Its unlikely anyone
    relies on this quirk, but can be easily worked around if
    necessary.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 9f32b03930802040ba1001258d824aefafd003d0
Merge: 1a8db01 7a87594
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jul 13 16:17:39 2012 +1000

    Merge branch 'release-script-fixes'

commit 1a8db01e896514d06f7a69c647aac05832d54ea7
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Jul 12 17:23:00 2012 -0700

    Add Cintiq 22HD
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7a875941c326db3ff257b6debd79279c62285c9f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 10 09:59:03 2012 +1000

    release.sh: support other modules (i.e. libwacom and input-wacom)
    
    Add a --module switch to the release script so we can use the same script
    for all three linuxwacom projects.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 28ddd9285d8dc3273a3ef6bf0a4fc34af97c6546
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 3 08:52:52 2012 +1000

    release.sh: complain if tags are missing
    
    Previously we only checked the previous tag, not the current one. Move the
    check up a bit, make it more explicit.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 9d42bcf72b9a0a4699deb29e3781859a1e68017f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 10 09:37:55 2012 +1000

    release.sh: remove gz tarball handling
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 5d85fe22a2b8565b80185c110d10a738b51794fb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 3 09:02:37 2012 +1000

    Stop generating .gz files
    
    One tarball is enough and bz2 is common enough that we don't need both.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 3ac24ba7aea62f1a12d73a81fca87a4bcfa5568e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 29 10:16:03 2012 +1000

    Don't init the rotation property on the pad
    
    Rotation doesn't do a lot on a device without usable axes
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit f5b89e44aa70d5297330014694c04d46f6e96a72
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Jul 9 09:56:54 2012 -0700

    wacom 0.16.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 35ba79a91257e9da5c8d749be382ec1841c78057
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jun 27 15:25:45 2012 -0700

    wacom 0.15.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit ed550599a71defd879ef6a660ab64db5f2961394
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jun 27 11:07:39 2012 -0700

    Cleanup wcmInitAxes
    
    No functional change.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 6bf3c65d44ce343bf8d2f0d0f1bb9bc86aba3fe1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Jun 27 11:00:44 2012 -0700

    Provide consistent 'filler' axes to X
    
    Axes which aren't used by specific devices 'leak' some of the
    settings of the prior axis while creating the necessary 'filler'
    axis. This patch resets the variables to their proper defaults
    for each valuator's initialization.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 1e14dda8a512b90cf9dd5d830d1e1257e80651c4
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Jun 22 12:44:47 2012 -0700

    Create a wrapper for InitValuatorAxisStruct
    
    wcmInitAxes calls InitValuatorAxisStruct seven times, with each
    call requring two ifdefs each. To keep this function readable,
    this patch adds a wrapper function that centralizes all that
    ifdef uglyness into a single spot.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 00560b81d700d04518beef9cf5bfa7c58b4a8d51
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Jun 25 12:21:44 2012 -0700

    Find mouse buttons on pad devices if no generic buttons found
    
    Devices like the Graphire4 and Bamboo-series have Pad buttons
    which emit "mouse button" events (e.g. BTN_FORWARD) instead of
    the usual "generic button" events (e.g. BTN_0). Currently, the
    code considers the former to be valid for the Pad device only
    if the tablet doesn't also support a Cursor device. Devices
    with mouse buttons on the Pad *and* have a Cursor device
    (like the Graphire4 and very early Bamboos) end up declaring
    zero Pad buttons because of this, causing us to allocate
    an insufficient number of actions and thereby prevent the
    re-mapping of their forward and back buttons.
    
    This patch changes the condition from "no Cursor device exists"
    to "no generic buttons exist". In theory this can result in the
    Pad claiming it has buttons when none physically exist, but it
    shouldn't result in any problems.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Acked-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 23b704aab02903954a2184708dcecf42ad896ac9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 22 16:04:45 2012 +1000

    xsetwacom: fix leak in set()
    
    move out: statement up to make sure we free values on error as well.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit bef544bef0be59f9fdff9231ce85cd41e4149975
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri May 25 10:09:37 2012 -0700

    Re-enable relative wheel scrolling from pad devices
    
    Commit 477a261e does not handle the case where relative wheel events
    come from a pad device. The Graphire4 produces such events, with the
    result that scrolling with one has been broken ever since.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6973a8e0256ba2b2d84ce73058da23b2fd1668c6
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 11:16:03 2012 -0700

    Align returned type of wcmEventAutoDevProbe with expected type
    
    There's some cognitive dissonance when reading "return FALSE"
    in a function that returns a pointer (despite FALSE and NULL
    being equivalent).
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fb22158f3361afa68808a10e2eece00617921faf
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:31:25 2012 -0700

    Fix warning: Re-scope variable in wcmPreInitParseOptions
    
    ../src/wcmValidateDevice.c: In function 'wcmPreInitParseOptions':
    ../src/wcmValidateDevice.c:801:9: warning: declaration of 'b' shadows a previous local [-Wshadow]
    ../src/wcmValidateDevice.c:708:22: warning: shadowed declaration is here [-Wshadow]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 19681d6a8bb0a4dbcf5fb9174d79ea6232ac895a
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:02:09 2012 -0700

    Fix warning: Remove variable re-definition in wcmSerialValidate
    
    ../src/wcmISDV4.c: In function 'wcmSerialValidate':
    ../src/wcmISDV4.c:167:7: warning: declaration of 'n' shadows a previous local [-Wshadow]
    ../src/wcmISDV4.c:161:6: warning: shadowed declaration is here [-Wshadow]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit def7b5fd2776b0455eca09641df8ed1c5e17bd37
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri May 25 12:18:05 2012 -0700

    Fix warning: Swap empty string for NULL in wcmIsHotpluggedDevice
    
    ../src/wcmConfig.c: In function 'wcmIsHotpluggedDevice':
    ../src/wcmConfig.c:442:2: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type
    [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmConfig.c:24:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b798ae8012a13a0dcaa903e0fdb4ad8e38106b41
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:22:30 2012 -0700

    Fix warning: Swap empty string for NULL in wcmIsAValidType
    
    ../src/wcmValidateDevice.c: In function 'wcmIsAValidType':
    ../src/wcmValidateDevice.c:139:2: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmValidateDevice.c:23:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit afac3b0430386d92d31623b065e9ed206e9cdcdd
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:20:23 2012 -0700

    Fix warning: Swap empty string for NULL in wcmNeedAutoHotplug
    
    ../src/wcmValidateDevice.c: In function 'wcmNeedAutoHotplug':
    ../src/wcmValidateDevice.c:574:2: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmValidateDevice.c:23:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit de33b3dffbb959ec77c9bd89c7d9d3e7a8451c15
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:18:17 2012 -0700

    Fix warning: Swap empty string for NULL in wcmIsDuplicate
    
    ../src/wcmValidateDevice.c: In function 'wcmIsDuplicate':
    ../src/wcmValidateDevice.c:85:2: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmValidateDevice.c:23:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cff344b105318854ae2b0a9dec3684be38c5ae02
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:16:16 2012 -0700

    Fix warning: Swap empty strings for NULL in wcmCheckSource
    
    Also cleans up variable scope.
    
    ../src/wcmValidateDevice.c: In function 'wcmCheckSource':
    ../src/wcmValidateDevice.c:37:2: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmValidateDevice.c:23:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmValidateDevice.c:52:4: warning: passing argument 3 of 'xf86CheckStrOption' discards 'const' qualifier from pointer target type [enabled by default]
    In file included from /usr/include/xorg/xf86str.h:43:0,
                     from /usr/include/xorg/xf86.h:44,
                     from ../src/xf86Wacom.h:33,
                     from ../src/wcmValidateDevice.c:23:
    /usr/include/xorg/xf86Opt.h:87:24: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d691c978d695c2b4882b4ba3e02178bd3aacddb3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:08:28 2012 -0700

    Fix warning: Constify 'name' argument of InitWcmAtom
    
    ../src/wcmXCommand.c: In function 'InitWcmDeviceProperties':
    ../src/wcmXCommand.c:175:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:179:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:186:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:194:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:197:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:201:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:205:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:209:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:212:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:216:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:220:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:225:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:228:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:234:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:238:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:244:3: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:249:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    ../src/wcmXCommand.c:254:2: warning: passing argument 2 of 'InitWcmAtom' discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmXCommand.c:121:13: note: expected 'char *' but argument is of type 'const char *'
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3639e07e837eefe7a6820899548ef0d6eb2d0722
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 12:05:35 2012 -0700

    Fix warning: Remove superflous 'event' pointer in usbParseBTNEvent
    
    ../src/wcmUSB.c: In function 'usbInitToolType':
    ../src/wcmUSB.c:1378:30: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 39145f819b745fe0122e70d0686d3b4dbf80cca1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 11:52:06 2012 -0700

    Fix warning: Constify _WacomCommonRec.device_path
    
    ../src/wcmConfig.c: In function 'wcmPreInit':
    ../src/wcmConfig.c:507:26: warning: assignment discards 'const' qualifier from pointer target type [enabled by default]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 912ed64c594bfc03b99b693df32fe3fa6a9c82c3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 11:41:12 2012 -0700

    Fix warning: Change default_options to be const
    
    ../src/wcmConfig.c: At top level:
    ../src/wcmConfig.c:212:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:212:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:213:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:213:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:214:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:214:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:215:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:215:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:216:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:216:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:217:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    ../src/wcmConfig.c:217:2: warning: initialization discards 'const' qualifier from pointer target type [enabled by default]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 706d2a77396d9c912e1d9157359e07923c8c718b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 11:19:04 2012 -0700

    Fix warning: Have wcmEventAutoDevProbe return const
    
    ../src/xf86Wacom.c: In function 'wcmEventAutoDevProbe':
    ../src/xf86Wacom.c:527:5: warning: return discards 'const' qualifier from pointer target type [enabled by default]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1d203a20bd21f8bdb22e36e93b67b651dd73743c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 11:10:10 2012 -0700

    Fix warning: Remove superflous casts in getScrollDelta
    
    ../src/wcmCommon.c: In function 'getScrollDelta':
    ../src/wcmCommon.c:333:13: warning: cast from function call of type 'double' to non-matching type 'int' [-Wbad-function-cast]
    ../src/wcmCommon.c:334:9: warning: cast from function call of type 'double' to non-matching type 'int' [-Wbad-function-cast]
    ../src/wcmCommon.c:335:10: warning: cast from function call of type 'double' to non-matching type 'int' [-Wbad-function-cast]
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2adab89eb2c73b7806aade5b422adba4056d8fd8
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon May 14 16:56:02 2012 -0700

    Add 0xED and 0xEF
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7ee27fee0741cc756dfd20a60afb3de1c9e0ed1b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 2 14:22:27 2012 +1000

    conf: add Intuos4 WL (PTK-540WL) to fdi file
    
    4709394d76267df05f8dfa7f13e6beb1f9c7394f added it to the xorg.conf.d
    snippet. For those stuck on HAL add it to the fdi file too.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Przemo Firszt <przemo@firszt.eu>

commit 904443623df7f293f6d87e85e0b808183afe67c9
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed May 2 10:25:01 2012 -0700

    wacom 0.15.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 311be3952d3557720bbb5e0203066ca1864f74ef
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 24 11:40:58 2012 -0700

    wacom 0.14.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 5fab61b10aabdc5b5461798f9002669adf18f263
Author: Adam Nielsen <a.nielsen@shikadi.net>
Date:   Wed Apr 11 16:13:08 2012 +1000

    Add support for the DTI-520
    
    Signed-off-by: Adam Nielsen <a.nielsen@shikadi.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 35d855025bb26e0a2daac9b08b4ea868512fb9ab
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 6 14:10:00 2012 -0800

    Add support for the Intuos5
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 466b119b12a0e149a3b79a031878e04d89c628c4
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 3 13:13:22 2012 -0700

    Fix off-by-one error in xsetwacom's button handling
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 52a795d2fb1fee5b13e95a2c7089dd87c37d2ea8
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Wed Mar 21 22:27:22 2012 +0200

    conf: Only match tablet Waltop devices
    
    Only match Waltop event devices classified as tablets.
    
    Advanced Waltop tablets have on-the-frame controls such as multifunction
    dials (controlling scrolling, zooming, volume and keyboard navigation) and
    keyboard modifier buttons. These are represented as separate event devices
    and are better handled by xf86-input-evdev.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5e0c6ff52e9fb25e0fcd8228992ffc7a41b1db8e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:36:47 2012 +1000

    Don't dereference priv before checking it for NULL
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit d23809af1613a93ad5b68623cadd4d122da32820
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:36:04 2012 +1000

    Plug minor memory leak
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 99a9542cb14b763ddf417c71d4966f80eda417fe
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:34:06 2012 +1000

    Avoid buffer overrun
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit f0e338a4bb54d69a0c83207651efb739d843a469
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:32:55 2012 +1000

    Don't pass NULL to fclose(3)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 8b59c9ff369c1b148f716dbc6234ead68311fa21
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:29:56 2012 +1000

    Fix broken NULL check
    
    This check was ok until 7958bb9b1ddef9e8238615fd1b3d15996f00effe, when more
    code was moved here and it made no sense this way anymore. Change it to
    return early in the case of NULL allocation.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 61146662a1c3ffff87b71506f3f0c06a18a069a6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 21 15:28:17 2012 +1000

    Check ioctl return value
    
    Really, this shouldn't ever fail but at least it shuts up some static
    analysers.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit fe2d108dbd2d0769e314a32c9b11376919adcea6
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 14 12:24:04 2012 -0700

    Don't share names of action atoms across properties
    
    The names of action atoms are currently created without regard to
    the property they will be stored in. This results in both e.g.
    button 1 and StripLeftUp using atoms with the name "Wacom button
    action 1". When setting either button 1 or StripLeftUp, we ask
    the server for an atom named "Wacom button action 1" and in both
    cases receive the *same* atom. This means button 1 is nothing
    more than an alias for StripLeft up (and similarly for the other
    actions which share the same name).
    
    This patch uses the name of the property the action will be stored
    in as the prefix to prevent this aliasing from occuring.

commit 220d3fb0bc1cbc9cee4f771f310c36cb07d7af68
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 15 08:05:27 2012 +1000

    man: fix typo in xsetwacom man page
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2ec45ba39ad5c43e97e8ed02e37ebbdc3f41668c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 9 18:17:58 2012 -0800

    wacom 0.14.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit c2c1a42d4dd97b26dee395b5911bee209fddf030
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 6 16:33:31 2012 -0800

    wacom 0.13.99.2
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 8e22ba6d8cfe9a21ea40b959152318efe8e0b338
Author: Colin Walters <walters@verbum.org>
Date:   Fri Mar 2 07:24:17 2012 +1000

    wcmXCommand: Fix invalid array size for serial values.
    
    Introduced in c21b6876b435bb34112956716fea14477ef9e8d7
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 60b4c868ac5baf5dba82c8c9146dfac068c06eef
Merge: e7564c9 28abd26
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Mar 1 09:48:50 2012 -0800

    Merge branch 'master' of git://people.freedesktop.org/~whot/xf86-input-wacom

commit 28abd26ba9379004db8667eaa2fcd2aa0b3d6fc4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 28 11:27:28 2012 +1000

    xsetwacom: fix compiler warning
    
    xsetwacom.c: In function ‘set_output’:
    xsetwacom.c:2359:6: warning: variable ‘success’ set but not used
    [-Wunused-but-set-variable]
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 6a862efd7f3d8504b600e9d67c2b9b43e41ee8d5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 28 11:18:12 2012 +1000

    xsetwacom: re-add ToolID with the current tool ID in proximity
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit ef11021997c850d0d3e579777468ec6d52f28f20
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 28 11:16:57 2012 +1000

    xsetwacom: ToolID is actually ToolType
    
    ToolID should be the ID of the tool in proximity.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit c21b6876b435bb34112956716fea14477ef9e8d7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 22 16:52:52 2012 +1000

    Export current tool ID in the property too
    
    Previously, we exported old serial number, old tool ID and current serial
    number. Export the current tool ID as well.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Tested-by: Bastien Nocera <hadess@hadess.net>

commit e7564c941e8ac5ab9549332730844b2380b9e641
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Feb 29 15:24:31 2012 -0800

    wacom 0.13.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 00b784202448dfc8f1e142c3745053ae1e82b042
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Feb 29 15:12:27 2012 -0800

    Change return type of 'test_flag_set' to void
    
    Compiler complains that nothing is being returned, but nothing
    *should* be returned.

commit 632134f4697935ada00d72bc19286f551b42da53
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Feb 10 12:00:03 2012 -0800

    Extend length of wheel_actions array to 6
    
    This array was apparently overlooked when adding support for the
    second touch ring present on the 24HD.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 45fd72c9031ed88e4af26b43cbb51d1c64e88602
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Dec 22 13:41:43 2011 -0800

    Remove AC_CORE status print
    
    Flag is deprecated, has no effect, and serves no purpose anymore.
    Remove from the DBG statement.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6240c226ef429ade3926be0a65341117de2b24e5
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Feb 9 11:07:39 2012 -0800

    Check for appropriate number of properties when setting buttons
    
    Commit 7e92aca6 changed the length of the Wacom Button Actions
    property to be dynamically calculated, but did not take this
    into account for the property setter (preventing xsetwacom from
    updating them). This patch replaces the constant length with an
    identical calculation to ensure we check for the proper size.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5a2221de13f73c7edbe4221909225ef5c7c5c18a
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Feb 7 10:57:05 2012 -0800

    Remove redundant redeclaration of 'wcmInitialScreens'
    
    From GCC:
       In file included from ../src/xf86Wacom.c:46:0:
       ../src/xf86Wacom.h:147:13: warning: redundant redeclaration of
       'wcmInitialScreens' [-Wredundant-decls]
       ../src/xf86Wacom.h:146:13: note: previous declaration of
       'wcmInitialScreens' was here
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4709394d76267df05f8dfa7f13e6beb1f9c7394f
Author: Przemo Firszt <przemo@firszt.eu>
Date:   Fri Feb 10 17:55:16 2012 +0000

    Add Wacom Intuos4 Wireless to 50-wacom.conf
    
    Intuos4 Wireless doesn't match list of devices in 50-wacom.conf, so evdev was
    taking over. This patch fixes it, so now wacom driver is used fo Intuoe4 WL
    PTK-540WL
    
    Signed-off-by: Przemo Firszt <przemo@firszt.eu>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 96a2e90c0f6a727fe6942c7b8f05b37167a10ab1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sat Feb 4 19:20:44 2012 +1000

    Move some usb-specific keys to wcmUSBData.
    
    nbuttons and npadkeys is only used for USB-specific parsing, move them
    there.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 7e92aca68a666499c7d6f1946cc849cfb5653ae0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 3 19:15:54 2012 +1000

    Initialize button action properties for the correct button number (#45557)
    
    Previous code had the number of properties for button actions hardcoded to
    16 (WCM_MAX_MOUSE_BUTTONS). Drop that define and instead initialize the same
    number of properties that we have on the device as well.
    
    X.Org Bug 45557 <http://bugs.freedesktop.org/show_bug.cgi?id=45557>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit b6fd73d4f79b4731caee4dc72e9f6fcecd2b5161
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 3 19:21:28 2012 +1000

    Compress button counting statement
    
    No functional change, just compressing several lines into one.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit bc7db7f1ef57beab2a149ca9589cea08f5e69af2
Author: David Foley <favux.is@gmail.com>
Date:   Sun Jan 29 11:18:43 2012 -0600

    man.wacom: Fix typo in Touch Gestures.
    
    Fix initiates typo in TOUCH GESTURES' Vertical scroll.
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 16749eb2d82166a3389fe6209c654bb1fce2e639
Author: David Foley <favux.is@gmail.com>
Date:   Thu Jan 26 13:10:23 2012 -0600

    man.wacom: Add gesture description.
    
    Add description of the touch gestures to the wacom manual.
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dbc25fa4fd86af7ccd42af04e6360dfdd0336735
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 12 13:40:27 2012 +1000

    Allow for a threshold of -1 to reset to the built-in default (#43221)
    
    This switches interpretation of the property from unsigned to signed. Not a
    big deal, since the maximum value has always been 2048 anyway and on 32-bit
    that doesn't actually change anything.
    
    X.Org Bug 43221 <http://bugs.freedesktop.org/show_bug.cgi?id=43221>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 09b1aa6538cd48e20928da9a835999dfc851f62c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 10 11:55:14 2012 +1000

    Fix wrong check for configdir
    
    We care about configdir, not sysconfigdir. Otherwise, --with-config-dir=""
    on a server that does support xorg.conf.d has no effect and the fdi files do
    not get installed.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8a8931cc77babbd84a4ec7a1df04e995aaa1e980
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Jan 16 10:03:10 2012 -0800

    wacom 0.13.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit a94a6fbaa5bde44d1d6fc2f33f56d6ffddefca75
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 6 13:26:19 2012 +1000

    release.sh: set announces' Reply-To to the linuxwacom-discuss
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 933905070d6fd6e438b7a5ff445570e1fad1e70a
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Jan 3 09:29:51 2012 -0800

    wacom 0.12.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 5ca665dd77b074d95fd0d9191f544b022eaaddd8
Author: Alexey Osipov <simba@lerlan.ru>
Date:   Tue Jan 3 15:13:48 2012 +0700

    'Left mouse button' dragging support.
    
    First, we define two new GESTURE_ modes:
    - GESTURE_PREDRAG_MODE - when first tap happen and we wait for second touch.
    - GESTURE_DRAG_MODE -  when actual drag happening (left button pressed).
    
    Second, we define tap timeout function wcmSingleFingerTapTimer(), which
    simulate single click if no drag operation started within timeout.
    
    Third, we make an exception for GESTURE_DRAG_MODE in wcmCommon.c, because
    we actually want cursor movements while dragging. This exception is made
    through new function wcmTouchNeedSendEvents().
    
    Now, to do a single tap you just tap (touch and untouch). Actual click
    happens after TapTime period.
    To drag something you make a tap (touch and untouch) and then quickly
    (in TapTime period) touch device again. Then drag.
    
    Signed-off-by: Alexey Osipov <simba@lerlan.ru>
    Reviewed-by: Chris Bagwell <chris@cnpgabwell.com>

commit 1c5c25d7b4a4ce0686f6a088d282e437dbadadfe
Author: Alexey Osipov <simba@lerlan.ru>
Date:   Tue Jan 3 15:13:45 2012 +0700

    Create wcmTouchFilter.h
    
    Moving declarations for touch filter from xf86Wacom.h to wcmTouchFilter.h
    
    Signed-off-by: Alexey Osipov <simba@lerlan.ru>
    Reviewed-by: Chris Bagwell <chris@cnpgabwell.com>

commit a119545769f208d5722561a928a93824f87cdc81
Author: Alexey Osipov <simba@lerlan.ru>
Date:   Tue Jan 3 15:13:42 2012 +0700

    Fix cursor jumping after zoom and scroll gestures when in Relative mode.
    
    When touchpad is in Relative mode of operation, we need allow driver
    update internal old{x,y,z} variables to eliminate cursor jump after
    gesture ended. That update performed in wcmSendEvents() function in
    wcmCommon.c. So, when we in gesture mode, allow call wcmSendEvents()
    to update variables, but don't allow actual events sending to X server.
    
    Unnecessary axes modification removed from wcmSendButtonClick() in
    wcmTouchFilter.c, which was causing cursor movement in Absolute mode
    while gestures are active with respect to above changes. Call to
    xf86PostButtonEvent() replaced by call to xf86PostButtonEventP().
    
    Signed-off-by: Alexey Osipov <simba@lerlan.ru>
    Reviewed-by: Chris Bagwell <chris@cnpgabwell.com>

commit 7a7af3eb1c5e809aa7020795b3c170f6360d6c5f
Author: Alexey Osipov <simba@lerlan.ru>
Date:   Tue Jan 3 15:13:38 2012 +0700

    Extra right clicks removed.
    
    As right click performed with second finger, then we only interested
    in second finger touch when trying to match 'right click' gesture.
    
    Signed-off-by: Alexey Osipov <simba@lerlan.ru>
    Reviewed-by: Chris Bagwell <chris@cnpgabwell.com>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit ba851feb1a5f28ff3e68ef07bc84a7d75e3444ea
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Dec 30 09:26:00 2011 -0800

    Remove testing code
    
    This bit of code slipped in between v4 and v5 of the "add abswheel2"
    patch. It was testing code that was never intended to be part of
    the 24HD patch set, and wasn't caught until too late.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 3989bdb4b42cbd44f7dd99b244eeb4d1618a7ff3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Dec 21 13:13:11 2011 -0800

    Expose the second touch ring's raw value in a new 7th valuator
    
    This patch expands the number of valuators reported by devices to
    seven. The new seventh valuator reports the raw value provided from
    the kernel for the second touch ring.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 7e3b2b9223629119472469569a2e23150e5c0c68
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Dec 21 09:30:22 2011 -0800

    Have the second touch ring emulate wheel events by default
    
    Touch strips as well as the first touch ring are set up to emulate
    mouse wheel events by default. This patch duplicates this behavior
    for the second touch ring, so that it behaves in an identical manner.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ced9465599434c68fa40210aa890970386a08b84
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Oct 17 17:11:19 2011 -0700

    Add 'abswheel2' to device state for dual-ring devices
    
    This patch adds an 'abswheel2' field to the _WacomDeviceState
    structure, along with corresponding 'oldWheel2' field to the
    _WacomDeviceRec structure. These fields store the state of the
    second touch ring on dual-ring devices such as the Cintiq 24HD.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fe1dc1753010809a7741f05784b5abe9d2ee5cff
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Dec 12 09:20:31 2011 -0800

    Add basic support for Cintiq 24HD
    
    Adds the Cintiq 24HD (056a:00f4) to the device lists. The 24HD
    has two features not found on prior tablets: three capacitive
    buttons, and a second touch ring. Subsuquent patches will
    address adding support for them.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 477a261ef79172d6378613fc4cab0026ed49d02f
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Dec 21 09:26:46 2011 -0800

    De-duplicate code for wheel/strip scrolling
    
    Replaces sendWheelStripEvents and getWheelButton with several
    small functions to reduce unnecessary code duplication.
    
    As a side-effect, it is now possible for the driver to handle
    simultaneous scrolls on multiple axes. Previously, getWheelButton
    would go through all the axes but was limited to returning a
    single button/action.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a60e59a4730d6a11f999085aa8754fd0de5dfbaf
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 19 13:18:03 2011 +1000

    test: fix linker error 'input_option_new' undefined
    
    We need a copy of it in the driver. This is just the one the driver uses for
    pre-ABI 14 compatibility, we don't need the server's exact copy since we're
    not testing that API (that's the server's job), only our use of the API.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit d54d936146fa58fb10a1b6839e1413671f96f86e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 19 13:01:35 2011 +1000

    test: add more #defines to fix build issues.
    
    sigh, upstream changed the option function prototypes without bumping the
    ABI. This is the best we can do, though there will be a period between the
    actual abi bump and this commit where we get test build errors now.
    
    commit 09e4b78f7944234865f4648940453303af0c2663
    Author: Alan Coopersmith <alan.coopersmith@oracle.com>
    Date:   Mon Nov 7 19:19:47 2011 -0800
    
        Fix gcc -Wwrite-strings warnings in xf86 ddx
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 388c2630881d74b10bcd0aad57796c9e09341471
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 19 12:59:53 2011 +1000

    test: drop duplicate definition of xf86FindOptionValue
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit c6dba3dab054be19921a11f8ee38f847e4ef8962
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Tue Nov 22 20:18:44 2011 -0600

    Remove wcmTapTimeDefault variable
    
    Its not really needed anymore. The whole *Default variable concept is
    at least partially related to historically the PAD device was Init'ed
    before the TOUCH device on Bamboo's but that is no longer true.
    
    And since the TOUCH device is now Init'ed before PAD, when PAD
    got Init'ed, wcmTapTimeDefault would override Touch's TapTime value;
    probably not what user wanted.
    
    For times *Default was really useful, I think wcmPostInitParseOption()
    is probably a better replacement concept.  I'll slowly remove these
    *Defaults as I have time to test each behavior.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit b0aab508269acb3a8bf9e6699a4a283f374e8488
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Tue Nov 22 20:12:21 2011 -0600

    default gesture distance values based on hw maximums
    
    2 finger Gestures will start working on a wider range of
    hardware with different resolutions now.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit f9fe7c7b74418378a5fc09a03c2da381a87b4561
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Mon Nov 21 21:52:28 2011 -0600

    Break option parsing into two init phases
    
    This is ground work to allow much easier overriding of
    default values for case were exact default value is not
    known until after init phase (for example, if default value
    depends on resolution of hardware which is not known until
    after init phase).
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 31dbd9fc9fdd3691d9ef43c707ecc780e0c62d24
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Nov 14 11:43:56 2011 -0800

    xf86-input-wacom 0.12.0
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit 22a26f34ba4f47a648cd01d87aa649033db2e1e1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Nov 14 11:12:00 2011 -0800

    Fix include reference to wacom-util.h
    
    Running "make distcheck" fails under the quoted path.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit e4aa352f0ded30fcc3ec90a187957f6f8920fd8e
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Nov 14 16:52:35 2011 -0800

    Have usbInitToolType return the old tool type if available
    
    If the tool was not specified within an event packet, the
    usbInitToolType function would return TOUCH_ID. This caused
    problems for combined pen+touch devices when the pen was in
    range, since only the first packet (which explicitely specified
    the STYLUS tool) would not be filtered as "single touch"
    data.
    
    This patch passes along the old tool type, so that if no
    tool is found in the current packet, the old tool type may
    be adopted.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit f7c0a64bf6550ac8ada19345bd03916bd4aa8890
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Nov 14 13:04:24 2011 -0800

    Fix usbInitToolType to not always return TOUCH_ID
    
    Commit ca922994 changed usbInitToolType to use the tool
    TOUCH_ID by default. Because of the way the 'for' loop just
    below is handled though, the function would never return
    anything but TOUCH_ID. This patch changes things to only
    return TOUCH_ID if no data for an alternate tool type
    could be found in the event packets.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 20958f84eef0b40f91e4559099f342f28650c183
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Oct 26 12:33:48 2011 -0700

    Use xf86PostButtonEventP for held button action releases
    
    It appears that commit 485137ef partially missed this particular
    call in its mass-migration away from xf86PostButtonEvent. This
    results in the pointer jumping away from the correct location
    when a held button action is finally released. It is most noticible
    when the action "button +1" is assigned to the stylus or eraser and
    a window is dragged.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2f233f62544f9419a6f12e201d09189339f7c1d2
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Nov 9 11:41:23 2011 -0800

    Migrate Tablet(Has|Set)Feature to use the wacom-util macros
    
    In addition to consolidating code, this happens to fix a bug
    in the implementation of TabletHasFeature which would return
    true provided *any* bit of a multi-bit mask was set. Ever
    since 7c667678 when WCM_TPC was changed to a multi-bit mask,
    tablets with WCM_LCD set have been (mis-)treated as tablet PCs.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 2c4360d7be38f242a89f2da291e075b28e0dfc51
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Nov 9 09:14:14 2011 -0800

    Only convert I4 tilt bits to rotation for the I4 mouse (v2)
    
    This re-implements commit 9be9719d78af035c45ea4b191c21fab0ee54f198.
    Ping pointed out the device_type field that I had somehow missed
    when making the earlier commit. This provides essentially the same
    information as the IsCursor() macro that the original patch went
    through so much trouble to use.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ef47fa044b6bc3949c0b8d96c665d18937da719b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Nov 9 08:59:58 2011 -0800

    Revert "Only convert I4 tilt bits to rotation for the I4 mouse"
    
    This reverts commit 9be9719d78af035c45ea4b191c21fab0ee54f198.
    Under the right conditions, the 'tool' pointer can be NULL,
    leading to the X server crashing. An easy way to trigger the
    crash is to spam pad events (such as button presses) while
    holding the stylus on the edge of proximity.
    
    Rather than fix this with additional checks for NULL, Ping
    clued me into a much more elegant (and bug-free) way to
    implement the check for an I4 mouse. See next patch.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 882795767a975854f373d58a9b15a57dfa244f28
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Oct 21 16:22:53 2011 +1000

    Deal with opaque InputOption in ABI 14
    
    Input ABI 14 makes the InputOption struct opaque, so use the new API
    provided (and wrap for older ABIs).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5cdd524f9986bc8bc628d953379c5eb8c0003c9b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Sun Oct 30 20:13:51 2011 -0700

    wacom 0.11.99.1
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit ee6abf754d08b6b073c2494353db68b7275fdac3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Oct 20 16:59:46 2011 -0700

    Add 0x10804 to recognized Art Pen device IDs
    
    Intuos4 Art Pens may have an ID of 0x10804 for their tip and
    0x1080C for their eraser. There may be other IDs which need
    matching as well, but that is a "to investigate" item for the
    moment.
    
    Note that due to a mostly-benign issue in the kernel driver, the
    highest nybble of the ID is placed one nybble *too* high. Until
    a proper fix is made and tested for the kernel, we need to check
    for an ID of "0x100804" instead of "0x10804".
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 64f72480396f4398f0ad03aabc7b570d606c290c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Oct 20 16:59:45 2011 -0700

    Correct Cintiq 21UX2 features to advertise touch strips, not rings
    
    Moves the 0xCC case (21UX2) to be in the proper spot. There are
    touch strips, not rings on this device.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9be9719d78af035c45ea4b191c21fab0ee54f198
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Oct 20 16:59:44 2011 -0700

    Only convert I4 tilt bits to rotation for the I4 mouse
    
    The comment claims that the conversion is to be performed for the
    I4 mouse only, but doesn't actually check to see if the tool is
    indeed a mouse. This patch adds in the necessary check, allowing
    the I4 stylus to properly report tilt data.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fff28802c2a803525d30cb8cb27c385f3e589f8a
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Oct 19 17:01:08 2011 -0700

    Process pressure only when it is supported
    
    normalizePressure crashes if wcmMaxZ is 0.
    
    Signed-off-by: Ping Cheng <pingc@wacom.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8a803975522bbb94e7df41c806dd2a573f058585
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 23 14:23:31 2011 +1000

    Handle ABI 14 option types
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5544d3aeec362f09d2a68b10834f2be31c7bd1f0
Author: Eduard Hasenleithner <eduard@hasenleithner.at>
Date:   Sun Oct 9 15:22:19 2011 +0200

    Make InitWcmAtom support arbitrary property types
    
    InitWcmAtom could only create properties of type XA_INTEGER or
    XA_ATOM. This commit adds support for any atom type by means
    of adding a type parameter to InitWcmAtom. All instances of
    InitWcmAtom use are adapted to the new parameters.
    
    This is a preparation for a new parameter of type XA_PIXMAP
    needed for the upcoming OLED commit.
    
    Signed-off-by: Eduard Hasenleithner <eduard@hasenleithner.at>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 594deceed76e46617838dab2560ecbdf6b42421d
Author: Thomas Jaeger <ThJaeger@gmail.com>
Date:   Sun Oct 9 12:18:19 2011 -0400

    Exit gesture mode when pen comes in range
    
    Otherwise, the driver will be in an unusable state until the pen is lifted and
    the user touches the device.
    
    Signed-off-by: Thomas Jaeger <ThJaeger@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 705c6df5a75e3408b048d15cadd1652124767893
Author: Eduard Hasenleithner <eduard@hasenleithner.at>
Date:   Sun Oct 9 15:01:43 2011 +0200

    Fixing format strings in list_mod
    
    Two printf calls in xsetwacom.c were using a "%d" for output of an
    expression of type size_t. Changing format string to use correct
    "%zd" in order to avoid the format string warning at compile time:
    
    xsetwacom.c:787:2: warning: format '%d' expects argument of type 'int',
    	but argument 2 has type 'long unsigned int' [-Wformat]
    
    Signed-off-by: Eduard Hasenleithner <eduard@hasenleithner.at>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c0504a80c5b94323072326e0b1d78ed2378817e7
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Sep 28 11:52:44 2011 -0700

    Return boolean where required
    
    This particular return statement was missed in e9d9ddc3.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit f2ee4f22f2ab258f3c2cd615342c56c793835362
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Sep 20 11:25:22 2011 +1000

    Move DebugLevel options up.
    
    Having them in wcmParseOptions() means we don't get debug messages until we
    hit wcmParseOptions(). For new devices that don't initialize (for whatever
    reason) this makes debugging a lot harder.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit e9d9ddc309746f6e8537223fcf946d434ea188c0
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Sep 27 15:47:08 2011 -0700

    Have MapToOutput helpers return booleans to indicate success
    
    MapToOutput helper functions now return 'true' when they sucessfully
    change the transformation matrix, and 'false' otherwise. Though this
    information is not used at the moment, it will be used with the
    KeepShape patch to ensure that the active area is only modified if
    the output mapping occured sucessfully.

commit b1f0c9ac801e48de16c6afe3bf680565a4e5c5db
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 9 15:44:37 2011 -0700

    Have 'MapToOutput' require the keyword "desktop" to do such
    
    Instead of allowing zero arguments to map the tablet to the entire
    desktop, we require the use of the keyword "desktop" to accomplish
    this. This is to make it easier to figure out the user's intent
    later on when we introduce KeepShape.

commit 6da898eba50a8499d770214684bd3d2d46033037
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 9 15:43:29 2011 -0700

    Add 'set_output_next' helper for MapToOutput
    
    Adds a helper function for MapToOutput which determines which
    output the device is currently mapped to, and moves to the next
    available output. Repeatedly calling this function will result
    in the device being mapped to every available output (including
    the desktop as a whole) in turn.

commit f09def951b7bd8ca57894e15ea3a47cda96c6a00
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 16 17:25:12 2011 -0700

    Allow 'MapToOutput' to accept X geometry strings
    
    This patch allows the MapToOutput command to accept fully-
    specified X geometry strings as valid output names. The
    XParseGeometry function describes these strings as having
    the folowing format:
    
    [=][<width>{xX}<height>][{+-}<xoffset>{+-}<yoffset>]
    
    Strings with width, height, xoffset, and yoffset defined
    will be accepted and the device mapped to the rectangle
    it describes.
    
    This patch also renames the function '_set_matrix' to bring
    its naming in line with the other set_output_XXXX functions.

commit d0f15345546fc9396261ceaf2268cf0ddc7b32af
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Sep 6 18:13:49 2011 -0700

    Have 'set_output' check and convert arguments as necessary
    
    The 'set_output' function is now responsible for parsing the
    command-line arguments to both determine the proper function
    to call, as well as converting them into a form that can be
    more easily used by the helper functions. This patch also
    breaks the RandR compatibility check out into its own function
    to improve readability.

commit a19be46042e8e8213cc7f302429977590d0081f7
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Aug 5 10:34:20 2011 -0700

    Free RandR resources more-quickly
    
    We now call XRRFreeScreenResources as soon as practical to allow the
    now-following logic to return at its leisure. Additionally, we also
    copy the data from 'crtc_info' locally and free it ASAP.

commit 53633de3854f815682ca92ebf5c949a778697993
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Sep 16 17:24:16 2011 -0700

    Create wacom-util.h for generally handy defines
    
    The new wacom-util.h should be the place to store defines which
    may be handy to use anywhere. At the moment this includes things
    like ARRAY_SIZE, bit manipulation, and mask manipulation defines.

commit 59c54a39fae39fb580cce3c3b676d658e7ad593b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Sep 9 08:36:33 2011 +1000

    Revert "make gesture distances be relative to hw maximums."
    
    Accidental push, this patch is still pending a few more modifications before
    it's ready. See the thread at
    http://sourceforge.net/mailarchive/message.php?msg_id=28006798
    
    This reverts commit 259616580c1ef3f624d8f984f69f3991d57bbe9c.
    
    Reported-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fb11287b1ca76a838e2fdde67d6267d8dd5979b4
Merge: 2596165 a9c7b56
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Sep 8 14:14:39 2011 +1000

    Merge branch 'gesture5' of git://github.com/cbagwell/xf86-input-wacom

commit a9c7b56aa13992ec11b87c726699cf685857640c
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Jun 25 19:38:51 2011 -0500

    do not send touch button during gesture holdoffs
    
    Moved 4 different places were the touchscreen button press was done to a
    single location.
    
    This allows to NOT send a button pressure while gesture detection
    is being performed.  That unwanted button press could do some annoying
    things when trying to do a 2 finger scroll on a touchscreen.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit cb92037af882d2479d0f677eba8be83b11632dcd
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Wed Aug 24 18:26:29 2011 -0500

    improve 1 finger tap validation
    
    Added check for wcmGesture for 1 finger gestures since it couldn't make
    use of generic check.
    
    Skip 1 finger tap on touchscreens based on LCD feature instead of
    is_absolute() value.  Also, since this is gesture specific validation,
    moved to inside function.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit 89c88966f0adbf56abcd8087fe51a4ee36e17102
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Tue Aug 23 20:52:45 2011 -0500

    Add a GESTURE_NONE_MODE in place of 0 values
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit c1ba7642b7a8567fd945e04cc9ad9e1bd1014576
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sun Sep 4 22:10:01 2011 -0500

    look at current packet during 2 finger gesture lag
    
    Probably the original logic meant to be doing something like:
    
    "if (ds[0].proximity && dsLast[0].proximity && ds[1].proximity)"
    
    but it left out the ds[0].proximity part.  This had two issues:
    
    1) We got 1 extra packet worth of movement because of delay in
    going into LAG mode upon 2 finger touch.
    2) It could go into LAG mode upon releasing 1st finger before
    second finger.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit 68daad26c11d70aeaffd8d4d4f81f14487f321c2
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Tue Aug 23 20:42:28 2011 -0500

    improve initial 2 finger behavior
    
    When trying to do a 2 finger scroll, the cursor was previously
    moving around until taptime because wcmGestureMode was mistakenly
    being set back to zero.  It was falling into 1 finger else {}
    case once past WACOM_GESTURE_LAG_TIME.
    
    To see issue, try scrolling in a web browser or terminal window on a Tablet
    PC and you'll see lots of unwanted text selection because of cursor
    movement + button press.
    
    Rearrange code so that coming out of LAG will never happen in two finger
    case.
    
    Also, rearrange related logic to be more obvious for 1 finger vs 2 finger
    case.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit 3005fc0f7caff5a375fa2e353d3bcbadfd59382e
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Tue Aug 23 19:31:51 2011 -0500

    reduce 2-finger scroll holdoff time
    
    The only reason not to immediately go into 2 finger scroll
    and zoom mode are:
    
    1) Make sure user is not going to do a 2 finger time based gesture
    (only 2 finger tap supported).  Waiting only taptime is fine for this.
    2) Wait for some movement of fingers to see if its a zoom vs. scroll.
    This is movement based and not time based.  Reducing time doesn't seem
    to change behavior here.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit 259616580c1ef3f624d8f984f69f3991d57bbe9c
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Aug 27 12:03:19 2011 -0500

    make gesture distances be relative to hw maximums.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b4c5e7047e32635d958ba0181eb63451b930521c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Aug 24 11:50:25 2011 +1000

    Don't compare unsigned values to < 0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit df7db361dd8ce04bec486ee7215ae51a2e339d0e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Aug 24 11:46:46 2011 +1000

    No need to check for pInfo != NULL in PreInit
    
    We've dereferenced it several times already and having the check in there
    confuses static analyzers who don't know that the server allocates this for
    us.
    
    This is a leftover from pre-ABI 12 where the drivers had to allocate pInfo
    themselves.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Jason Gerecke <killertofu@gmail.com>

commit 557a52b8a1ea7f10773f49e3d43074bb3952120e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Aug 24 09:38:45 2011 +1000

    man: clarify rotation on hotplugged devices
    
    Dependent devices take the parent device's rotation, not hotplugged devices
    in general.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit f1519288f53144860379a193c7c1c579d014a04c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 12 10:29:53 2011 +1000

    man: document gesture-related options
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 1fa07c06020c8d6c983002999c04c519b58c4892
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 12 10:04:47 2011 +1000

    man: Add RawSample to man page
    
    Text copied from xsetwacom.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 21985216fe57eba9c7419f2c1e9dc3989833e5cd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 12 10:03:53 2011 +1000

    Update comments for wheel and TwinView resolution properties
    
    A bit more detail on the wheel property to make it easier to understand
    without reading the code.
    
    TV resolution is deprecated, mark it as such.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit cf5986b7e546443f16cd86dbb46c8ba334382081
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 23 13:38:14 2011 +1000

    Sanitize condition to check for complex gestures.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit 992738ff9f0d0c3eb2b6f3be9851d3c2c506ad4f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 9 15:02:26 2011 +1000

    Fix an error message.
    
    This error may have been in wcmEvent now, it's not anymore. Either way, one
    can just grep for the string, the function name is irrelevant.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 473e339593d79e8e4d417698ff61ccaeb6e53096
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Aug 1 17:53:12 2011 -0700

    Allow zero-argument use of MapToOutput to reset map to entire desktop
    
    If zero commandline arguments are provided to 'set_output', we
    now interpret that as the user's desire to remap their tablet to the
    entire desktop. This is accomplished by loading the identity matrix.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7f3da2baed602d75559003066d41c77f7ee96056
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Aug 1 17:51:55 2011 -0700

    spellfix: "Dize" -> "Size"
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b2e5813935f6897bd3a2c7ee5be4a3db17f58745
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Aug 1 17:51:00 2011 -0700

    xsetwacom: Have 'get_param' respect PROP_FLAG_INVERTED
    
    Running e.g. `xsetwacom get stylus TabletPCButton` would display
    the wrong value to the user because the property is inverted.
    This checks to see if PROP_FLAG_INVERTED is set, and to swap the
    result if so.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7353f1dbd4472c485bd7e248413a9d21d3a77a89
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 20 15:21:19 2011 +1000

    If the type isn't valid for our device, say so.
    
    Don't just quietly fail PreInit.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit ad82c03c9ca876d2c2518b2fc2c1a652ea74ce8b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 18 16:02:40 2011 +1000

    Use xf86SetStrOption to get type
    
    This call prints the value (if set) to the log, making it easier to debug if
    something has gone wrong.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 5e2f39a390bbbebe59d49ec35a79641dba7de7fe
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 18 15:58:29 2011 +1000

    Print error to the log if the Type option is missing.
    
    Static configuration devices only.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 16d30d475d1997fe7271236dc18854eabe1c2dc7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 18 15:08:05 2011 +1000

    Protect against NULL-pointer dereference in UnInit
    
    If priv is NULL the DBG macro would dereference it. priv may be null if
    wcmAllocate() fails or the event device cannot be found..
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit c1368da8e637a9a6bb1b1c09b30b3c8e63442ec3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 18 09:50:19 2011 +1000

    test: Fix tests for Capacity removal
    
    Removal of capacity caused a few tests to fail. Fix this.
    
    Introduced in xf86-input-wacom-0.11.0-36-g6c9c05e
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 4f1041122f1544b660f80b5a9aad086a3f6da372
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 18 09:45:56 2011 +1000

    isdv4: fix pressure parsing
    
    Missing shift would report the wrong pressure maximum.
    
    Reported-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 983185c64b9fa725519ff5a1e0863e7bac00bea4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 13 10:03:40 2011 +1000

    man: reshuffle Authors list
    
    Not to discredit Frederic's work, but he is not involved with the project
    anymore.  Users have a tendency to email the first person on the list, let
    that go to someone who is currently involved and likely to respond.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 4c3b4e0a88401a55fbdd98ba4db128d9a52583d1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 13 10:02:19 2011 +1000

    man: use placeholders to man pages listed in See Also
    
    These are substituted on build, the sections aren't the same on all
    platforms. Not that this really matters for us (linux-only) but it's in-line
    with other X.Org projects.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 3a72150505eb8077215029c365c31740ca966bd6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 13 10:00:18 2011 +1000

    man: add link to our website in See Also
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit f63be64a58629cfac2077da8be335e02d10f3c5d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 13 10:05:42 2011 +1000

    man: add paragraph before the link to linuxwacom.sf
    
    And spell out sf as sourceforge
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 44a25ab9305e452465b0bbf7547624f18c896459
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 14:03:15 2011 +1000

    Fix comment typo
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 66925f068638c4cc3181478008e5a909de389940
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 14:01:01 2011 +1000

    ISDV4: swap packet parsing condition around.
    
    No negative conditions where not nessary please.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 7ab2f8a74a4dc7b1f795490f3850129d43fdb3c8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 13:41:43 2011 +1000

    Split isdv4Parse into two functions for touch/pen packets.
    
    No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 42132efc7f22a353f5d5976cb898abd1ea04e761
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jul 1 09:15:55 2011 +1000

    xsetwacom: plug minor memory leak
    
    data is allocated, needs to be freed. No real impact since xsetwacom will
    exit anyway after this.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 70afb81f6de2f29e23eded3d1db74749e98e6daa
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jul 1 09:14:50 2011 +1000

    Remove unused variable "device"
    
    ../src/wcmValidateDevice.c: In function 'wcmHotplugOthers':
    ../src/wcmValidateDevice.c:515:8: warning: variable 'device' set but not
    used [-Wunused-but-set-variable]
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit aa4e458e50150bfc976afcb32034f0a30a404bf1
Merge: f8e6ccc a8829f0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 30 16:22:53 2011 +1000

    Merge branch 'capacity2' of git://github.com/cbagwell/xf86-input-wacom

commit a8829f06de49585c2bbc3d47c86cdea0720ee1ff
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Jun 25 12:34:36 2011 -0500

    Support pressure curve with touch pressure
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6c9c05e7dfadb6fc49f11a6541a18b1f84f8c844
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Jun 25 12:07:12 2011 -0500

    Remove unused Capacity logic on touch devices
    
    The feature never fully worked and bits have slowing been removed.
    Remove remaining in one swoop.
    
    As apart of removing logic, now store ABS_PRESSURE values in the more
    appropriate "pressure" location so that it can eventually be exposed in
    the Pressure axis that touch devices create but do not currently send.
    
    Additional changes beyond this patch are required to get Pressure Axis
    working on touch devices.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>

commit f8e6ccc0a494d6bf82afbd81698baa2f78436cd6
Merge: 006bc89 7fe557d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jun 29 08:54:16 2011 +1000

    Merge branch 'nvidia-twinview'

commit 006bc892fa132f4ba71ef23bb2043847bb3ece2e
Author: David Foley <favux.is@gmail.com>
Date:   Mon Jun 27 20:43:58 2011 -0500

    Add 3 new models: 6A, 6B, and 97
    
    Adds the new Bamboo1 small (6A) and medium (6B).  Adds a slate form factor tablet PC (97).
    
    Tested-by: Alex Tervoort <alex.tervoort@gmail.com> for 6A
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ca92299423980a9be5560f6eb29ba949356d638f
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Jun 25 13:05:52 2011 -0500

    Default to touch tool for multi-touch devices
    
    We really need to add hooks to query pre-existing device state when
    input driver starts up because slot ID is almost never sent when
    touching 1 finger to screen.
    
    In mean time, it makes sense to default device_type to most likely
    value of TOUCH (the T in MT) for this function used only by MT
    devices.
    
    The default of zero is causing some events to be filtered mistakenly.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7b67f9e0d59811af879f7cea3422395fb83d0663
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sat Jun 25 13:05:50 2011 -0500

    Show maxZ value for touch devices in debug output
    
    Some, but not all, touch devices support pressure.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ed83c973802c4f3f34faa166ccfebbfdc5414e49
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Thu Jun 23 22:06:59 2011 -0500

    Set WCM_TPC when generic tablet is detect.
    
    This allows unknown touchscreens to work as expected (default to
    absolute mode for example).  We no longer need to update case
    statement in wcmDeviceTypeKeys() each time a new ID is used with
    new hardware.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3e0aea20fd9e262edb717e046f9d1cc1f9e12834
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Thu Jun 23 22:06:58 2011 -0500

    remove redundant WCM_LCD setting for WCM_TPC's
    
    WCM_TPC definition already includes WCM_LCD.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 85d82c3279ffc0dec3be14a7da2e00e375f87f03
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Thu Jun 23 22:06:57 2011 -0500

    Fix CintiqV5 LCD defaults by using new TabletSetFeature()
    
    Some of the previous usage of "=" instead of "|=" could
    cause previous settings to be lost.  Only known case was
    for CintiqV5 losing WCM_LCD value.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6ec94774890452c5c82b0b9db64d7738948fbe19
Author: San <sanette-linux@laposte.net>
Date:   Thu Jun 23 17:53:56 2011 +0200

    Correct the up/down orientation of Touch Strips
    
    Tested on cintiq and intuos 3.
    
    Signed-off-by: San <sanette-linux@laposte.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Tested-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 47e13394f468c8a500428f62752ab60aaf1d0ce0
Author: David Foley <favux.is@gmail.com>
Date:   Tue Jun 21 21:14:49 2011 -0500

    conf: Add WALTOP back into MatchProduct
    
    The WALTOP kernel driver patches are in the mainline kernel tree now.
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7fe557d404a2e7aa192ff68ebdec5436696c9f4a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jun 20 13:52:30 2011 +1000

    xsetwacom: Support MapToOutput for TwinView.
    
    The NVIDIA binary driver doesn't support RandR 1.2 but it does support
    Xinerama. Due to a server bug, we still get the current server's RandR
    version back when we query, so we need to check to the binary
    driver-specific NV-CONTROL extension first. If that or a RandR < 1.2
    version is present fall back to Xinerama if we need to.
    
    User commands:
        xsetwacom set "device name" MapToOutput HEAD-0
        xsetwacom set "device name" MapToOutput HEAD-1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit 4578d4f4b84e5bb23855e7aa66e6b54fe3b836fc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jun 20 13:38:02 2011 +1000

    xsetwacom: move matrix calculation into a separate function
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit c684649cde60772402407f398f3dbec7e8e7b909
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jun 20 13:06:33 2011 +1000

    xsetwacom: split output setting into set_output_xrandr
    
    Preparation work for NVIDIA TwinView support.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jason Gerecke <killertofu@gmail.com>

commit f5fcbd8b4a74d1087b7efb4129a1240e86eaf2b5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jun 20 13:49:43 2011 +1000

    xsetwacom: add missing linebreak in error message.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jason Gerecke <killertofu@gmail.com>

commit 36fca6055911d86e902555671b4d206f6fae1835
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Jun 20 17:34:07 2011 -0700

    Fix invalid rotation values
    
    For a rotation of "NONE", the rotation would be whatever happened to be on
    the stack.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c5a0be2d944f28c944d605ccc5e03371e15d97ee
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sun Jun 5 08:08:07 2011 +1000

    Export the device node as property (fixed version)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d79a302ae4c9ae7bf9386ec683ae502023878015
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sun Jun 5 08:06:46 2011 +1000

    Revert "Export the device node as property."
    
    This reverts commit 2e9972c4419cef47ac08528bbaf02846ae4fc915.
    
    Broken patch, XI_PROP_DEVNODE replacement wasn't consistent.
    
    Conflicts:
    
    	src/wcmXCommand.c
    
    Reported-by: Andrzej Giniewicz <gginiu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1ba90110b34a287ffce92e9cf2700179fbab4400
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 2 12:33:11 2011 +1000

    Add support for Device Product ID property.
    
    This property is now used in input drivers to export product/vendor ID to
    clients.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 2e9972c4419cef47ac08528bbaf02846ae4fc915
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 2 12:10:12 2011 +1000

    Export the device node as property.
    
    X doesn't provide a mapping between physical devices and X device IDs other
    than what can be extrapolated from the device name.
    Export the device node so clients that need e.g. sysfs or other information
    from the kernel can map the devices.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 8713d0c90b994b259f7c0430ac4726884c7e3d10
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 2 12:25:38 2011 +1000

    Clarify a comment
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 933db3e4627ecaf448f3fd5c457b2f5b455edcbc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 2 11:58:23 2011 +1000

    Fix a wrong comment
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 5c45c941493651ab9108e1416737ef89e485d67b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 27 09:34:11 2011 +1000

    release.sh: add reminder to bump configure.ac after a release
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 05280f008d2de2dade0d9b15bd8551b1dbee7e51
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 27 09:33:33 2011 +1000

    Bump to 0.11.99
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c6b979e24d56823f30c5ee922a86c138dbe64341
Author: David Foley <favux.is@gmail.com>
Date:   Tue May 24 17:12:22 2011 -0500

    wcmValidateDevice.c: Add 0xE6
    
    Adds the E6 2FGT tablet PC.
    
    Tested-by: Ethan Schoonover <es@ethanschoonover.com>
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4e42edf896dfb4facab9c4f8b217226648100109
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 18 15:32:27 2011 +1000

    man: note that parent devices can't be matched.
    
    MatchProduct "stylus"
    
    won't work since the "stylus" bit is appended by the driver, after the
    server has already applied the MatchProduct directives. This only applies to
    the parent device.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit 63c885670bde3b10b4755075bb4af6466b3dc46d
Author: David Foley <favux.is@gmail.com>
Date:   Thu May 12 14:19:28 2011 -0500

    wcmCommon.c: fix cw and ccw swap
    
    Return cw and ccw to expected behavior.
    
    Tested-by: Buran Ayuthia <the.ayuthias@gmail.com>
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 85dd620e2664d1f374a2c4aad27bf0bed41118ab
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 14:32:56 2011 +1000

    Force all serials to be unsigned.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 429e9d569d9907f7954384dab433f2a267f173e1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 15:30:34 2011 +1000

    Add a property to bind the device to a serial number.
    
    This is a read/write property to force the device to a single serial number
    only.
    
    xsetwacom parameter BindToSerial
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit a4ce692ea35911fa597eff477e209c4ec49af79e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 15:03:44 2011 +1000

    Rename iserial to serial
    
    iserial is confusing. It may be hungarian notation or it may be an index for
    the serial. In this case, it's simply the serial number, so name it
    "serial".
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 59b985c939e70a530db7726a3cf5e84bbb1b74ed
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 15:02:56 2011 +1000

    Add some more documentation to the new serial hotplugging code.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit aa89172deace263fca239ce9fdbcdc1e928d4e62
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 15:01:52 2011 +1000

    Make wcmHotplugSerials static
    
    This isn't called from anywhere but the hotplugging code.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit acd2181f87dfc1f7d20a6eca7b80914ced48c62c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 13:16:07 2011 +1000

    xsetwacom: add ToolSerialPrevious to retrieve the last tool in proximity.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 488782ca502074821aeec026e2e940add068e819
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 12:58:19 2011 +1000

    Only update old_serial when going out of proximity.
    
    And set cur_serial to 0 when that happens.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit a88102fafbab8075162032b1d3ee0bce4da625b5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 12:48:42 2011 +1000

    Update the device's serial number when it comes in.
    
    Split serial number internally into
    - serial: the serial number this device is bound to, 0 if unbound.
    - cur_serial: current serial number in proximity
    
    Then update the serial property with the current serial. Because of SIGIO
    malloc restrictions, the property must be updated through a timer function.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 85a2c91fb8b489968ac21f848d75a7c8b3d1c207
Author: Alexia Death <alexiadeath@gmail.com>
Date:   Thu May 5 11:40:57 2011 +1000

    Get the latest values for serial numbers when a client asks for them.
    
    Whenever a client requests the property values, update them from the current
    device state. Due to race conditions with the SIGIO handler, we have a
    window between updating the device state (during the handler) and updating
    the property and sending events (requires alloc, thus not in the handler).
    
    If a client asks for the property value, update from the state so the window
    only affects property events, not actual values.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 8f1c120bc68231d312794bc6479514f45820b74f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 11:25:47 2011 +1000

    improve documentation for serial property
    
    - document serial ID property as read-only.
      It is already read-only in code, add a comment to say so in the header
      file.
    - serial values are unsigned.
    - document hw device id as such, it's not the device ID libXi clients see
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 2c94cc7554c3874567ab999a64ef086505576e83
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 13:11:16 2011 +1000

    xsetwacom: add missing arg_count to a serial/tablet ID parameters
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 7af794a2acdee4bdc6e3ad73d6c4f42598e9a87e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 5 13:15:24 2011 +1000

    xsetwacom: add a bit more tracing to the get code.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 21c25ef7b3eda57ab00c1f2576cfba0e4ef9dba4
Author: Alexia Death <alexiadeath@gmail.com>
Date:   Mon Apr 18 11:26:43 2011 -0700

    man: Describe ToolSerials option
    
    Adds a description of the "ToolSerials" option to the driver manpage.
    Slightly modified from Alexia's original patch (breaks the list of
    types out into the description)
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1284bc5a858557a2739b67de401d25bcab3e1cf6
Author: Alexia Death <alexiadeath@gmail.com>
Date:   Mon Apr 18 11:26:40 2011 -0700

    Add ToolSerials option for hotplugging pens
    
    Provide a new "ToolSerials" option which describes tools that should
    be automatically hotplugged along with the standard devices. This is
    achieved by parsing "ToolSerials" while the master device is being
    initialized to create a WacomTool list. This list is then used while
    hotplugging child devices to create tool-specific devices with the
    "Serial" option set appropriately.
    
    The "ToolSerials" option should be added to the 50-wacom.conf file
    in /etc/X11/xorg.conf.d so that it is applied to hotplugged tablets.
    The option takes the following format:
    
    Option "ToolSerials" "serial[,type[,label]][;...]"
    
    Or, for a more concrete example:
    
    Option "ToolSerials" "113246231,airbrush,Airbrush;85983311,artpen,Artpen"
    
    ToolSerials recognizes the "pen", "airbrush", "artpen", and "cursor"
    types. Unknown (or unspecified) types default to creating "pen"-type
    tools with both 'stylus' and 'eraser' devices.
    
    Signed-off-by: Alexia Death <alexiadeath@gmail.com>
    Acked-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    
    Squashed in:
    Have ToolSerials patch re-use existing infrastructure
    
    This tweaks the prior ToolSerials patch to use the existing
    infrastructure where appropriate. For instance, using the 'WacomTool'
    struct instead of the custom 'WacomToolSerial' struct.
    
    This should actually be integrated as a "fixup", but is included
    here to more easily see the changes from the original.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 74a53cf8aa9ded9978d8f085446871d266dd4bf4
Merge: 0d7790b ec23bdd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 19 16:04:25 2011 +1000

    Merge branch 'next'

commit 0d7790b80ded4a33b6a81ebc0f8f11ccfbd27fa9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 19 14:05:44 2011 +1000

    wacom 0.11.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ec23bdd01334dbb655d97c85b1a366ac7eaf830c
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Apr 14 17:06:11 2011 -0700

    Retrieve resolution from the kernel whenever we can
    
    The resolution table has been added to the kernel driver. Let's use
    it when we can.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5b073528db237c46fdd3281e73a36f81ef494791
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 12 11:12:20 2011 +1000

    Add mask checking macros.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7958bb9b1ddef9e8238615fd1b3d15996f00effe
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Apr 7 15:23:28 2011 +1000

    Move common default values to wcmNewCommon()
    
    No functional change, just moving initialisation to where it belongs.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 3081ecb428d29c639cb2874958b8f95be6978ede
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Apr 13 15:43:49 2011 -0700

    Fake resolution for 9F and E2
    
    9F and E2 are touch only devices, for which we need to retrieve
    the resolution from the kernel. So, the resolution defined in
    WacomModelDesc does not count for anything. However, to avoid
    future questions about the weird "394", align them with their
    cousins.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3beefe834692048dd04d877a05bb85e0ed7c4c80
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 12 12:06:11 2011 -0700

    man: Use __drivername__ instead of "wacom"
    
    Because hardcoding things is uncool
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 432f3cb434d707bc516f930bd9ee1863685e2110
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 12 12:06:10 2011 -0700

    man: Fix __drivername__ macro
    
    It seems we've been having this macro dangling in our manpage since
    0862aa3d74378abbf9f23289ab864a4d07305d0d
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e6743f3c8adc54c4a6d19e2e1fcd884091145c90
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 12 12:06:08 2011 -0700

    man: Update usage information
    
    The usage provided by '--help' is more accurate than that provided
    in the man page, and some arguments to '--set' do not require a
    value.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 52408eac9cf497a410952284046b8fed3aa32d4b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 11 13:42:42 2011 +1000

    isdv4-serial-debugger: return early if tcgetattr() failed.
    
    Fixes compiler warning
    isdv4-serial-debugger.c: In function ‘set_baud_rate’:
    isdv4-serial-debugger.c:127:6: warning: variable ‘rc’ set but not used
    [-Wunused-but-set-variable]
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8caa65efe358e12873ef3f8c17cd0d7a990a6419
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 11 13:40:20 2011 +1000

    xsetwacom: remove two unused variables
    
    xsetwacom.c: In function ‘keysym_to_keycode’:
    xsetwacom.c:964:6: warning: variable ‘group’ set but not used
    [-Wunused-but-set-variable]
    
    xsetwacom.c: In function ‘get_actions’:
    xsetwacom.c:1747:25: warning: variable ‘last_press’ set but not used
    [-Wunused-but-set-variable]
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 161bcb48340bb9ef0b694b5bd33c7e5ed5db3ce6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 11 12:13:00 2011 +1000

    Fix higher button events.
    
    Buttons higher than sizeof(int) weren't getting sent. The mod_buttons macro
    needs to test for the number of bits, not bytes.
    
    Introduced in 880512f84c26cddbfc1a8ff495890595424466f2
    
    Reported-by: Andrzej Giniewicz <gginiu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 58a258600cb1138c160c6625816897ea18e34cf2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Apr 8 11:25:01 2011 +1000

    wacom 0.10.99.2
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2bbbe4546f56cd825606eff870e4817766d2e654
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 5 15:37:04 2011 +1000

    man: add hotplugging info to man page
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1390685854f7eedcb6802adaba8df274e96a4177
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 5 15:21:07 2011 +1000

    man: remove reference about different zones - unsupported
    
    We ripped this out with 13a12bb852f8 Purge toolarea from device rec.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 77b9f3cafc32adad76100f293fde6599a671f22b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 5 15:17:45 2011 +1000

    man: don't mention the core pointer, it doesn't exist
    
    Obsolete since server 1.4
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4d854858ca4de352546de179e1039c43921e15bf
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 5 15:16:23 2011 +1000

    man: refer to both xorg.conf and xorg.conf.d
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2110435235c371da647a58647535cf8e268fb603
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 30 09:15:34 2011 +1000

    Don't accept invalid device types.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6e10b33b25ac99280b387f8692e46e55d6d9ca8e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Apr 8 11:38:28 2011 +1000

    xsetwacom: fix --help output formatting
    
    The excaping of the two quotation marks means we need extra spaces here.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b8404011790e4b06ee46b471195eefd05fa304a0
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 13:54:46 2011 -0700

    Have wheel and strip properties be "actions" instead of "buttons"
    
    Continuing with removing raw button code, we create the wheel and
    strip properties ready to hold actions. Prior to this, the properties
    would be initialized with the raw buttons; before xsetwacom could
    set them to actions they would need to be converted.
    
    This does away with the conversion step by following the mold already
    in place for buttons. With no more need for conversion, we can also
    nuke the conversion-related bits from xsetwacom.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f3a358796133e04dbf91e57c1bc4760002ba9b3c
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 13:54:45 2011 -0700

    Decrease minimum number of args to 'set' [allow wheels/strips "reset"]
    
    Since the worker functions now check that they have the appropriate
    number of arguments, its possible to decrease the number of arguments
    required by 'set'. Since all it really needs is a device number and
    a property, the minimum argc is now 2.
    
    A handy side-effect of this change is that its now possible to run
    e.g. `xsetwacom --set $ID StripLeftDown` to reset the action to
    its default. Doing the same with buttons has been supported, but
    wheels and strips were out of luck because they would require too
    few arguments to 'set'.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c78c2759a9b87db1078d760a0108b0f5dac5ed58
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 13:54:44 2011 -0700

    More strict argument-count checking
    
    Add/replace checks in functions to ensure that they have the right
    number of arguments to do their job properly. The worst offender
    here was the set() function -- providing too many arguments would
    result in it walking off the end of data structures (often resulting
    in a segfault)
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d7ea18239de51d84706810b555ff3b2855b8856f
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Apr 8 11:31:23 2011 +1000

    Change from prop_extra to arg_count
    
    When setting an XInternAtom property, 'prop_extra' listed
    the number of extra properties beyond the first that needed
    to be set. For instance WACOM_PROP_TABLET_AREA had a total
    of 4 properties, so prop_extra=3.
    
    To provide better argument validation though, we change this
    to 'arg_count' and list the total number of arguments
    expected. This doesn't really do anything for normal properties
    (since arg_count = prop_extra + 1), but does let us check
    for the proper number of arguments in odd cases (e.g.
    ResetArea takes 0 arguments).
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>

commit c5ba63ce8e45bdecb650db78c8e2bb9dd454bfb3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 13:54:41 2011 -0700

    Fail with warnings where possible
    
    For many commands, improper arguments cause a silent failure. The
    user is often given no indication if their command succeeded or
    failed. I've tried to find all the silent "return;" statements and
    provide some kind of warning message where possible.
    
    In some cases I've added in new checks to ensure that we have the
    correct number of arguments. I've tried to make checks as pedantic
    as possible, e.g. throwing errors about number of arguments even if
    the function ignores arguments.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 19656e837c4bd3711b033992566058be790b5095
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 13:54:42 2011 -0700

    More explicit input check for set_rotate
    
    Because of how atoi() works, any single non-number (other than the
    expected cw,ccw,half,none) would be interpreted as being equivlent
    to 'none'. Since the number of valid arguments is very small, we
    explicitly check each.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 02f5fe64df98c963c865845e79b3a20cfddb62ca
Author: Timo Aaltonen <tjaalton@ubuntu.com>
Date:   Thu Apr 7 12:25:32 2011 +0300

    Add support for Lenovo tablet ID 0xE6
    
    Signed-off-by: Timo Aaltonen <timo.aaltonen@canonical.com>
    Tested-by: Manoj Iyer <manoj.iyer@canonical.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 86fa0fb17e0cd34217e07671ac8f777c3fbe731f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 10:30:32 2011 +1000

    Update all tools rotation property when rotating one of them.
    
    All tools on the same tablet share the rotation value, so if one of them is
    rotated, all of them must be. Since the property value is stored in the
    server, we need to trigger it explicitly.
    
    Test case:
    $> xsetwacom set "device name stylus" Rotate half
    $> xsetwacom get "device name eraser" Rotate
    
    Should print out the correct rotation value.
    
    Fixes #3070450
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit fd952b4e69bd2b2f39df36d1d489fecb47e2ae3a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 15:33:34 2011 +1000

    Don't rotate hotplugged devices.
    
    We only rotate on a per-tablet basis, not per-tool. Don't accept rotation
    values on dependent devices (unless they're the same, then be quiet about
    it).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 5cf22a3a39799cb1c50298d73c34fd397ad717b1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Apr 6 11:24:05 2011 -0700

    Expand manpage documentation for "Button" parameter
    
    Include list of parameters that are supported, as well as an example
    of mixing keywords in one action.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1c76a5942b36844b2fee80ca28b8481744f984cf
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 5 17:49:27 2011 -0700

    Swap range of 'RawSample' and 'Suppress' in man page
    
    Looks like the range of these two options was confused a while back.
    Switch them so that the right option has the right range.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8d57fb1693fe3a78fc6002570a9c132c067f7919
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 5 17:49:26 2011 -0700

    Have man page reflect per-tablet nature of 'Rotate' option
    
    Change documentation to indicate that rotation affects all tools
    associated with the same tablet.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2c30edb2b6a9542e945623fe0e215a5c04281655
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 5 17:29:20 2011 -0700

    Cause '-V' option to xsetwacom to exit like '--version'
    
    Unexpected difference in behavior between two ways of specifying
    the same thing. '-V' no longer prints the version and continues
    to run the rest of the program.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 35d14d75a0d06e32f3583733fcc987879c6e15f6
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Apr 5 17:29:19 2011 -0700

    Correct order of arguments to calloc
    
    Not that there's much difference between 4*(256 bytes) and
    256*(4 bytes) of memory...
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6424d65c613ee024795b4d529c1d2473650e01f5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 15:31:50 2011 +1000

    Factor out rotation parsing and setting.
    
    No functional changes, prep work only.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit da6cbaf3c8b0bb9f5d993ec0291c5919b52ebdee
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 5 13:27:33 2011 +1000

    Rename hotplugged to is_primary in wcmParseOption.
    
    The parameter is true for the primary device only (i.e. the one that
    _triggers_ the hotplug). It is false for any driver-hotplugged device
    and false for xorg.conf devices. So "hotplugged" is a rather misleading
    name. Rename to is_primary instead.
    
    Document this and while we're at it, change the function to use Bool instead
    of int.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 1da14469d2cdfe68ddbe4d451a7e757ad2a4705b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 15:22:36 2011 +1000

    Remove superfluous call to wcmRotateTablet().
    
    This is a leftover from the times when we reconfigured the axes based on the
    rotation. It doesn't do anything these days.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit e0354b9fde1e489bd0c87aa7f34b827ce3e27778
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 13:34:30 2011 +1000

    xsetwacom: add PROP_FLAG_INVERTED for Hover Click/TPCButton
    
    The Hover Click property is inverse to the TPCButton xsetwacom
    option/xorg.conf option.
    
    This commit restores the original behaviour for the property as before
    f1ecd11c619f1f7eb7850dd2fb514307ca1dd1ce but fixes xsetwacom that users of
    xsetwacom won't notice the difference.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 5984c9aecc6f80d936f8b0f81a63f31cd23f2e19
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 13:29:59 2011 +1000

    Revert "Correct TPCButton property inversion"
    
    "Hover Click" and "TPCButton" are not the same meaning. TPCButton behaviour
    is that Hover Click is off and vice versa. Hence the property inversion is
    there on purpose.
    Add some documentation to make this public.
    
    This reverts commit f1ecd11c619f1f7eb7850dd2fb514307ca1dd1ce.
    
    Conflicts:
    
    	src/wcmXCommand.c
    
    Reported-by: Michal Suchanek <hramrach@centrum.cz>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit d855766a53c005d12a56be23f9fcfce5d5922aa7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 14:01:46 2011 +1000

    xsetwacom: modularise test for bool conversion.
    
    No functional changes, just making it easier to test for other features in
    the future. Some strings to test again have changed, but we really only
    need to test for sane true/false values anyway ("oFf" is not sane enough to
    worry about).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8f2dce908d1a591c315b61fce4d66346d4f2213a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 13:45:00 2011 +1000

    xsetwacom: constify convert_value_to_user
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 493e673a2e55356b1f53bd9b9229426f171f9094
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 15:45:15 2011 +1000

    Revert "Update all tools rotation property when rotating one of them."
    
    This commit is incomplete, shouldn't have been pushed.
    
    This reverts commit 570b9d06b20e3eb4e93501594d29e3b24d46d24a.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4ed300dbb3002230c578681fd86eebef414dc272
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 12:07:52 2011 +1000

    Only update bottomX/bottomY if they haven't been user-configured.
    
    wcmInitialToolSize() would xorg-configured overwrite BottomX/Y with the max
    values read from the tablet. Only set the two if they are non-zero (0 is the
    default value).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 1de7a780a392e363450967dfab8c3dd065fd0348
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Sun Apr 3 16:07:38 2011 -0700

    Centralize pen and touch arbitration
    
    With the introduction of multi-touch, the chances of getting touch
    events while pen is in prox have been increased. One obvious use
    case is that the touch events could be used for gestures while pen
    is in prox. However, we do not want two cursors compete on the screen.
    
    Link the pen and touch device once during the initialization stage
    instead of every time when we receive a pen event. Then, centralize
    pen and touch arbitration process so we can store the touch data in
    wcmUSB.c instead of discarding them. The touch events will only be
    ignored if it is a single touch event that causes a cursor movement
    while pen is in prox.
    
    Some cleanup in wcmUSB.c is needed. It will be considered when we
    make MAX_CHANNEL a dynamic value based on MAX_FINGERS. The
    MAX_FINGERS is going to be the maximum of ABS_MT_SLOT that we
    retrieve from the kernel. That brings us to the state to support
    XInput 2.1 and devices that have dynamic number of fingers.
    
    Note: this patch is based on the assumption that all devices
    connected to the same system have unique product IDs. That is,
    no two or more identical devices are connected. Identical devices
    will be properly linked when we find a decent way to distinguish
    them in the driver.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 307ad96795605fc39d2c454e4c7efde94ecbed3c
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Sun Apr 3 16:05:42 2011 -0700

    Add IsPen to cover both IsStylus and IsEraser
    
    It will be used more often when we need to compare touch events
    with pen events.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 570b9d06b20e3eb4e93501594d29e3b24d46d24a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 4 10:30:32 2011 +1000

    Update all tools rotation property when rotating one of them.
    
    All tools on the same tablet share the rotation value, so if one of them is
    rotated, all of them must be. Since the property value is stored in the
    server, we need to trigger it explicitly.
    
    Test case:
    $> xsetwacom set "device name stylus" Rotate half
    $> xsetwacom get "device name eraser" Rotate
    
    Should print out the correct rotation value.
    
    Fixes #3070450
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit bb29b90d29aa8ea25120c3db8b6ce9ca563cf202
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sun Apr 3 08:49:13 2011 -0500

    fix filter issue on MT bamboos
    
    Init tool device type is needed for all MT devices to do correct
    filtering; not just pen+MT tablets.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b9566151e6029f77dcf22526308dabb262400774
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Apr 1 14:54:05 2011 +1000

    wacom 0.10.99.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f72c358177a2b588c4915bf6fa5cd00f183c9486
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Apr 1 14:59:20 2011 +1000

    test: update Makefile for include folder
    
    Fixes make distcheck.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cd0738f41c875c8a2ad5444558c505b47898a7f1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 30 13:09:59 2011 +1000

    Move npadkeys to fix comment.
    
    Fixing the comment would do too, but it really doesn't matter.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 81f191d7ed9ec1187f37c1df36db0683f65bd4a3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 30 12:55:26 2011 +1000

    Replace manual array size with ARRAY_SIZE macro.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit b522fdb493cb378af3206793e0b44d6652f7427c
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 30 16:24:15 2011 -0700

    Check predefined serial number as early as we can
    
    Don't wait before we can post the events. Verify the serial number
    as soon as the information is accessible.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 155a4b96ae8f03d3c07a93622d4f1f1da266d174
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 10:32:15 2011 -0700

    Revamp button/wheel/strip getters
    
    'get_map' is the new getter entrypoint and attempts to determine
    the mapping present on buttons, wheels, and strips. It calls on
    'get_actions' (essentially get_special_button_map) and 'get_button'
    (an 8-bit XA_INTEGER version of the same) to determine this. If
    both fail to find a mapping, it falls back to the method originally
    used for non-actions: punt and ask XGetDeviceButtonMapping for
    something.
    
    When raw buttons are removed from the driver, it should be possible
    to replace 'get_map' with 'get_actions' (since everything will be
    an action at that point).
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0f20c9b1d94bd8a53e5e9b6cf1b6f599457a1dca
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 30 10:31:25 2011 -0700

    Merge 'map_wheels' and 'map_button' into a unified 'map_actions'
    
    These two functions are very similar, and have been merged together
    to provide a single conduit for all action mappings. Button-handling
    code requires a little bit of special-casing (we need to be sure to
    get a button to modify, and to change the arguments appropriately),
    but nothing remotely worthy of breaking into its own function.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5f0b0dd0ed106a99d356e95bb4b73fadba21194d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:36 2011 -0700

    Remove 'special_map_wheels' and 'special_map_buttons'
    
    Since neither function actually do anything that couldn't just
    be done in 'map_wheels' and 'map_button' respectively, we simply
    squash them together.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e9e7397cd1f1bc37f27992114cebd39f4ad93e12
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:35 2011 -0700

    Remove map_button_simple
    
    With parse_actions now handling simple button mappings, we remove
    this function which essentially duplicates its functionality.
    
    Note that there is a small difference in how the new parse_actions
    code and the old map_button_simple code handle things. The former
    Translates a single numeric argument into an action (e.g. "3" is
    turned into "button +3"). The latter cleared any existing action
    and used XSetDeviceButtonMapping to have X remap button events.
    
    To better explain the difference, consider the two following commands
    run in sequence:
    
    xsetwacom --set $id button 2 3
    xsetwacom --set $id button 3 button 2
    
    Under the old map_button_simple code, both buttons 2 and 3 would
    produce a right-click event. This is because the first command has
    X remap all "button 2" events into "button 3" events. Since both
    button 2 (by driver's priv->button[]) and button 3 (by the explicit
    action) produce a "button 2" event, X remaps both events into "button 3"
    events.
    
    Under the new parse_actions code, things are what you'd expect: button
    2 produces a right click and button 3 produces a middle click. If the
    user wants, they can use `xinput set-button-map` to remap the buttons
    the same way that map_button_simple did.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f66bf4568c8b7005ab5611ab1b8c5c0c3819b1e3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:34 2011 -0700

    Allow parse_actions to parse simple button maps
    
    If argv contains only a single numeric argument, we assume the
    intent is to perform a button press. We add the necessary keywords
    to make the parser happy, and then parse as normal.
    
    This allows map_wheels to handle the "raw button" case that it has
    been missing. While map_button_simple also does the same* thing,
    that's another commit :)
    
    *Actually, map_button_simple does /almost/ the same thing, but I
    highly doubt anyone relies on the subtle difference in behavior.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e9dae780cb549f48aaf376af2b6382604c2760a5
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:33 2011 -0700

    Make it clearer when actions are sent
    
    When I first saw this, I thought somebody forgot to put an else
    clause here; I completely missed that tiny return statement. This
    makes the reality a little clearer.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 357e3c3c50d81bd57bd412d7d6bde9120d367f4b
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:32 2011 -0700

    Add WACOM_PROP_WHEELBUTTONS to cursor devices
    
    This enables the "Wacom Wheel Buttons" property for cursor devices,
    allowing xsetwacom to set (rel|abs)wheel(up|down) actions. I'm not
    sure if there are non-puck cursor devices which should *not* have
    this enabled, but until somebody says otherwise... :)
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c416728a5656748075f6671805d8da3869af2522
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:31 2011 -0700

    Fix strip/wheel mapping
    
    Commit 2ce1c6b4 fixed a bug where X would crash after remapping
    strips or wheels. It made all the "keys" arrays one-indexed so that
    wcmUpdateButtonKeys would not write beyond the end of the arrays.
    
    This patch syncs the action lookup code with the use of one-indexed
    arrays so that the proper action is returned.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c7058d85a913d2f2a494667a640d4a25e6ca0e34
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 30 14:04:44 2011 +1000

    xsetwacom: add a comment to update button actions in the right order
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit db66113366af1054c625940ba38c207d15bd59c1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 29 16:18:30 2011 -0700

    Fix "buttons must be set twice" bug from d650b139
    
    *facepalm* I simply can't believe I didn't test this, but there's
    no denying the bug exists. Looks like the change to 'btnact_prop'
    *must* occur after the change to 'prop'. If it happens beforehand,
    then the driver appears to be eternally one step behind xsetwacom.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9e46d9776f6c57abc128ac12a9ef8c03ad242eac
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 30 08:32:25 2011 +1000

    Add some comments for device_id and device_type handling.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit c5cbebabe796e86b94467bb7de3387e4e708f40a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 20:45:22 2011 +1000

    Remove discard_first field from DeviceStateRec
    
    Obsolete since the removal of old serial devices.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 2cc298863457fe9e171cb2c7494b83f2d971ccdb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 20:45:21 2011 +1000

    usb: print invalid max value if we get one.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1421082661074a201ec2bd98b826ac4154cef9f0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 20:45:20 2011 +1000

    usb: swap two checks.
    
    If the absbit isn't set, don't bother with the EV_ABS ioctl.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 6e21f9c6a7abc79eb89d4c742ffd0cee6bf86552
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 20:45:19 2011 +1000

    usb: remove to superfluous linebreaks.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 2d55e561956dc7beb0aa6fd2d814c0540e654e34
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Mar 28 10:06:56 2011 -0700

    Change hardcoded string to already-defined constant
    
    WACOM_PROP_BUTTON_ACTIONS is already defined in wacom-properties.h
    Lets use it instead of all those magic constants.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 32d14dc4a9787356024020fd25e463a90a25f349
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Mar 28 17:51:34 2011 -0700

    Resolve the oldHwProx puzzle
    
    Change oldHwProx to oldCursorHwProx to better reflect its use.
    
    oldCursorHwProx keeps the hardware in/out prox state so we can
    set the MaxCursorDist for the next round of relative cursor
    movement when tool first comes in prox.
    
    For Protocol 5 devices, distance is reported as the maximum
    when tool is first detected. Then it is gradually reduced to 0
    when getting closer to the tablet. Protocol 4 is the opposite:
    distance is 0 when tool is first in prox. The value increases
    as the tool gets closer to the tablet.
    
    The maximum distance (wcmMaxDist) is model specific. They are
    retrieved from the kernel.
    
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Acked-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5fec376c46e3840fe2e3f838df67cefee1c0d6c6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 10:55:58 2011 +1000

    ISDV4: use libudev instead of manual syspath creation.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 4b475087b827d143df93c2acc0017a9b79ff859a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 11:37:39 2011 +1000

    ISDV4: update a comment, we may return tablet id 0x90 on failure.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit d650b1399d37e6f2b6f151b011d72b219a5405b8
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 25 17:32:56 2011 -0700

    Make set/unset code easier to understand
    
    Between the parsing code seperating the two halves of set/unset
    and the code being confusing in general, I've rewritten this
    to hopefully make its operation a little clearer for the next
    person.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5b27df4274ae59e0e279096ac46836564d22c2ea
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Mar 24 18:02:54 2011 -0700

    Make parse error more helpful
    
    When a set of arguments cannot be parsed, knowing the word that
    did not make sense doesn't help if you've used it more than once.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d6ac23b79ccf65d30f07dbb1986ad9d6773ecd30
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Mar 24 18:02:55 2011 -0700

    Don't use unset_prop
    
    We don't need to bother changing the device property if
    we're unsetting since we're just going to be deleting it
    anyway.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c932e062ba894e50d2dd4c2e653e86915597ee52
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Thu Mar 24 18:02:53 2011 -0700

    Return from function on parse error
    
    If the arguments to this function are only parseable up to a point,
    the function prints a warning but still makes the (partial!) requested
    change. For example, if the user runs:
    
    xsetwacom --set 10 Button 1 "key +a notakeyword -a"
    
    The program prints a warning about it not recognizing "notakeyword" and
    maps Button 1 to "key +a". Instead of making partial changes, xsetwacom
    should instead bail at the first sign of a problem.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c690302586bf352395ca7bd1299866a97cc054da
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Mar 24 15:36:03 2011 -0700

    Add CursorProximity to xsetwacom.man
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ed668c1b768967b3bf5a6174c16c6d3732c1b4fe
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 23 14:57:51 2011 -0700

    PAD is always on PAD_CHANNEL
    
    Don't assume the last tool was a pad, which confuses those tools
    that never receive a serial number. Keep PAD on the PAD_CHANNEL.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6278f4fe4afd3ae627ea676e3c655f1e3968cd8b
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 23 14:57:33 2011 -0700

    Fix a copy/paste error in usbFindDeviceType comment
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dfc8404bec1d9d4d5eb65a2d29779d7ae1a18d62
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 23 14:57:12 2011 -0700

    Support pen and MT on the same logical port
    
    Serial ISDv4 kernel driver, wacom_w8001.ko, provides both pen and
    touch events on the same logical port. Filtering touch events when
    pen is in proximity while allowing pen events (ABS_X/Y, etc) pass.
    
    Making this action configurable would make sense when XInput 2.1 is
    ready. At that point, we can post MT valuators while pen events are
    posted. Some code refactoring is needed to add a new channel to
    store the pen data as well as the 2FGT data.
    
    Defering the code refactoring until we support XInput 2.1.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 842f2e28f8ce90991bdb60921250c97a11101104
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 24 12:01:34 2011 -0400

    Silence compiler warning.
    
    ../src/wcmCommon.c: In function 'sendCommonEvents':
    ../src/wcmCommon.c:382:2: warning: 'value' may be used uninitialized in this function [-Wuninitialized]
    ../src/wcmCommon.c:329:22: note: 'value' was declared here
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 307f50afba024cb6558d7084f5a7d86ec76bd992
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 22 14:02:32 2011 +1000

    Fix strip_keys index, copy/paste error.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 880512f84c26cddbfc1a8ff495890595424466f2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 22 13:50:44 2011 +1000

    wcmUSB: change MOD_BUTTONS macro into a function
    
    Values in, values out. No magic state structs, keep it simple.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit aadf1e0d215e3e7dfe119c3e541d35854de2326a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 22 12:00:41 2011 +1000

    test: drop glib dependency
    
    We weren't really using any of the glib-specific stuff anyway, so just
    replace g_assert with normal assert and drop the dependency.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 91fb559b5b760c345333ec7ac67f429d61b44f9d
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Mar 21 17:56:09 2011 -0700

    Bring idtotype and findDeviceType to the style
    
    Make them into the usb family and follow the style guide.
    Consolidate tool id for the existing tools into three defines.
    Update findDeviceType to cover more cases so it may be called
    by other routines to retrieve tool types.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b0a6637a4cf262436fb21c2b734241f376289deb
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Mar 21 17:55:41 2011 -0700

    Move findDeviceType from wcmCommon to wcmUSB
    
    Serial model is not supported. So, findDeviceType is only used by
    wcmUSB.c.
    
    Now it is the individual model's, wcmUSB or wcmISDV4, responsibility
    to set the device type locally. For wcmUSB, since kernel input filters
    out duplicated events, we should retrieve the device type and
    associated events directly from the kernel to cover the case when tool
    is on the tablet during driver starts.
    
    wcmCommon.c will treat packet with undefined device_type as invalid.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 201d1c35c7de919714815be18b990e9acc570054
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Mar 21 17:55:18 2011 -0700

    Prepare for the removal of BTN_TOOL_FINGER for pad tool in the kernel
    
    BTN_TOOL_FINGER was borrowed to group PAD events. With the support
    of pen and touch on the same logical port, we can not use it any more.
    
    PAD events of generic protocol has already manually routed to the pad
    channel, the last channel of wcmChanel.
    
    This patch groups PAD events for protocol 4 and 5 by the device_id
    sent through ABS_MISC event. In/out proximity event is also set by
    the ABS_MISC event.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 09f6c0faade997da490c1cd0277eb7f2f6cc9ef3
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 18 18:01:17 2011 -0700

    Clear the correct amount of memory
    
    Though this doesn't result in any bad behavior at the moment, it
    could cause some serious headaches in the future.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2ce1c6b47ff1596093d48b5cfccaddf17c6d2924
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 18 18:01:16 2011 -0700

    Fix X crash after remapping touchstrips and wheels
    
    Crash first appears in ab311bf20535acd6e7201e024bc311e0e15b5b6b.
    This commit rewrote wcmUpdateButtonKeyActions with one-indexed
    arrays in mind and extended the 'keys' array in _WacomDeviceRec
    to make room. However, the 'wheel_keys' and 'strip_keys' were
    not updated.
    
    Running e.g. `xsetwacom --set pad StripLeftDown button 4` results
    in a call to wcmUpdateButtonKeyActions. Its call to memset oversteps
    the array bounds and just happens to zero the 'common' pointer. The
    next tablet event results in a segfault as the driver tries to
    dereference the pointer.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1427db0bfea8c015ddb713f49eb0f33450266e60
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Mon Mar 21 14:10:42 2011 -0700

    Enable left click for MT touchscreen
    
    Tools that are in absolute mode emit left click when the tool touches
    the surface. However, tools in relative mode need to locate the object
    on the surface before it selects (left click on) the object. That is,
    a second event (tap/leave/touch) is needed to trigger a left click for
    relative mode tools.
    
    Tools on touchscreen is in absolute mode. So, send left click
    down/up when the first finger touches/leaves the tablet.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1c0696570c78b3454a9d847e5e9fe91bf0f04e9c
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Fri Mar 18 15:07:24 2011 -0700

    Remove one FIXME
    
    Get the "f" out of the code as well as the root cause.
    
    A proper fix would be to use resolution to decide the distance.
    That can be considered when we push the resolution table to
    the kernel. Hopefully, at that time, we can also post MT events
    to XInput 2.1 and push the gesture support to the desktop.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1b8287e090c5d994a3f99eed227dbb08ad78c469
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 16 10:06:01 2011 +1000

    xsetwacom: add pgup and pgdwn as special keys.
    
    "Prior" and "Next" aren't quite that obvious so specialcasing seems
    warranted here.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 1cfe05195698583e002d19eb12fc6221639283df
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 16:22:33 2011 +1000

    xsetwacom: update the property when we have items to write
    
    Introduced in 22bc3028effbdc79d426c0b3dcf586734d4c7532, changed logic caused
    the property not to update in all cases.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7ed24d165121e167930e34a3ea8532e358c003f5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 15 11:54:49 2011 +1000

    Add fake symbols for serverClient and QueueWorkProc
    
    Broke linking of unit tests in
    94a8eabadd062de6ceed8563089b863d887f8770.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 863714247c8d6020748c0cf099f1e06caf6b2b06
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Mar 14 16:10:59 2011 -0700

    Add tests for convert_value_from_user
    
    Some basic tests to ensure booleans and non-booleans act like we
    want them to.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f58feb275b51f1f9e059e668609591434021559f
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 11 15:13:54 2011 -0800

    Expand recognized boolean input for convert_value_from_user
    
    We remove the case sensitivity requirement for off/on and also
    allow the use of "true" and "false"
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d4f44eddeb497ecfaa99449b565f6bdf46c3b9fa
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 11 15:13:53 2011 -0800

    Use strtol instead of atoi in convert_value_from_user
    
    atoi provides only the most basic string conversion capabilities,
    and makes determining if conversion was successful difficult (both
    "abc" and "0" would return 0). We use strtol and checks to ensure
    that it converted the entire string sucessfully before returning True.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 12eebced3f004a0bea2c85d2197897de28bf7781
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 11 15:13:52 2011 -0800

    Detect boolean conversion failure in convert_value_from_user
    
    Properties with PROP_FLAG_BOOLEAN set can only take on a restricted
    set of values. We detect if the string matches any of the allowed
    values and convert if possible. If not possible, the caller is notified.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e5af4b9928b983227cad711496d258cde5d62cfd
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Mon Mar 14 16:19:24 2011 -0700

    Change signature of convert_value_from_user
    
    Have it return true/false to indicate conversion success/failure.
    Note that in its current state the function cannot tell if there
    was a conversion failure...
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9ecc125c1c59b591a89e6f10b79b2e1e49c86165
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sun Mar 13 22:27:44 2011 -0500

    Initialize USB pad device once up front
    
    Streamlines normal execution some but also resolves an issue reported
    for older Bamboo's since its now executed for all protocol types
    and not just generic protocols.
    
    Older Bamboo's and Graphire series always keep PAD device in proximity
    so you can pretty much count on never recieving a BTN_TOOL_FINGER
    event.
    
    This does work of that missing event.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 33a031cab73424a0a1ea5ded36fa6631c9a5811e
Author: David Foley <favux.is@gmail.com>
Date:   Mon Mar 14 15:54:52 2011 +1000

    xsetwacom.man: Fix whitespace issues
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3c0a16ac630603bf966e0a9fc1ee6d5be4276156
Author: David Foley <favux.is@gmail.com>
Date:   Sun Mar 13 17:57:10 2011 -0500

    xsetwacom.man: add RawSample and Suppress parameters
    
    Add RawSample and Suppress to parameter description table.
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 301297d6423a3556fd94006d739a4afca82b5812
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 10:12:48 2011 +1000

    Re-vamp source inclusion for test build suite.
    
    test/Makefile.am included src/Makefile.am for the driver sources. However,
    that also lead to the driver being built twice, once in src/ and once in
    test/. On make install, test/wacom_drv.so would overwrite the
    src/wacom_drv.so and thus install a driver with all static symbols compiled
    as non-static.
    
    This caused the VCOPY bug worked around in
    9d227cd0bd985e7dcb7923974361145ba1d78713.
    
    Avoid this by moving the sources into a shared included Makefile and build
    an independent libwacom-test.la in the test directory.
    
    Reported-by: Eduard Hasenleithner <ehasenle@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Eduard Hasenleithner <ehasenle@gmail.com>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 36ea587badc947c027c40ee4387a2d5540a9a5b3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 11 09:30:45 2011 +1000

    xsetwacom: remove unused need_update
    
    Unused since ba77b532e6c2a0b7b05ab129009c1f614b089c37
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit a3b6e2079155c5774baabcd9e3c53b3336536e49
Merge: 43c82c3 69d3e93
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 14 15:42:00 2011 +1000

    Merge branch 'race-condition'

commit 43c82c3139ef8b9abee7eb79a8d9055df9874329
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Fri Mar 11 08:39:50 2011 -0800

    Remove XWACOM_MAX_SAMPLES
    
    XWACOM_MAX_SAMPLES is a duplicate of MAX_SAMPLES, and appears to have
    no reason to be included in the Xwacom.h header. We remove it and
    retarget all references.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 676b25e5ec5eb70d45d3228b28bef5c8a68ab7f6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 11 10:53:51 2011 +1000

    Reset tiltx/y after converting it to rotation.
    
    Quote from Ping:
    "Since tilt is only used as raw value to calculate rotation for I4 mouse,
    i.e., they are not posted as valuators, resetting them or not does not make
    a difference."
    
    Let's reset it to 0 then so we don't get confusing values during debugging.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit abfcc2ac187a4a7131503c0aa80e166ca384034e
Merge: 857ef81 90ba050
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 11 09:31:23 2011 +1000

    Merge branch 'wcmTilt2R-fixes'

commit 857ef8159451fe52cd999f523d9c500f6c32c0e1
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Wed Mar 9 09:52:57 2011 -0800

    Perform bounds checking on RawSample
    
    I made the mistake of setting this to zero and then bringing my
    pen into proximity. Ooops. X crashed. Looks like mathematics
    still can't handle getting the average of zero things ;)
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 90ba05056578405307e737620782a581b942ef62
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 14:18:13 2011 +1000

    Change signature of wcmTilt2R to return the rotation calculated.
    
    Take an input point, calculate the rotation and return it. No need to deal
    with device state structures, etc.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 1023572644c5f00a418043615e802484fcff6e71
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 14:13:37 2011 +1000

    Sanitize wcmTilt2R.
    
    Cleaning up the code, rewriting the calculations, documentating the steps
    taken. It's understandable now. Whoop-dee-doo.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 42dc7cb652c5cf84433aac2aa791dc9fdb39ec2b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 13:08:26 2011 +1000

    Add a offset paramater value to wcmTilt2R
    
    Say No To Hardcoding.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 08c5fc41ef3f81dafbb50856c589fdf4e9f5f89c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 09:39:15 2011 +1000

    Fix wcmTilt2R so it uses defines instead of hardcoded numbers.
    
    Every time number is hardcoded deep inside the driver, god kills a kitten
    and a little part of me dies (unrelated to the kitten death). Use the
    defines already.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 56c550a11b57ccdc3e0d9ebcdeb323734c7c48f7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 08:56:57 2011 +1000

    Document wcmTilt2R (and add a fixme)
    
    Because not everyone has hours to figure out what each function does.
    Come to think of it, I don't actually either...
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8d61689016b961a33e6950b09f191c16741dd608
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 11:15:01 2011 +1000

    test: write a non-test for wcmTilt2R
    
    It's non-transparent what wcmTilt2R actually does at the moment, so generate
    a test table from the current code and test against that. This
    way we at least know when we're breaking something.
    
    Exception: wraparound value generates +900 instead of -900.  We must not
    send +900, our max range is 899, then we wrap again. This function isn't
    supposed to generate this value, so manually fixed up.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8e4dabd64a611dd5571aef6aff8dfb5dd258655e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 09:41:48 2011 +1000

    Remove superfluous function declaration
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 65220fa0276cbec10b51832c2bf9946c4bbfc4e8
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Wed Mar 9 11:27:14 2011 -0600

    remove per-device filter function
    
    Over time, we've merged device specific filter routines
    into single version.  So there is no need for historic
    hook to register at runtime.
    
    ISDv4 devices never registered any filter which seems
    like it would result in jitter.
    
    Removed RawFilter() from WacomDevice structure and call
    wcmFilterCoord() directly from wcmCommon.c.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1af65269cd22ea69b5d0920922484e0b4be3f9f6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 10 12:04:21 2011 +1000

    Use xf86ScaleAxis for pressure normalization.
    
    And copy the server's xf86ScaleAxis for the test. Not ideal, I guess but oh
    well.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 0ee2a44a49ababe25dddc2b82dfa5a343fd7e893
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 8 17:50:44 2011 -0800

    Enable RawSample and Suppress
    
    The driver apparently didn't look at the RawSample option, and
    xsetwacom confused it's offset with Suppress. In other words:
    if you thought you've been tweaking Suppress, you've been tweaking
    RawSample. If you thought you were tewaking RawSample, you weren't
    doing anything.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 22fcd2305c1f7464bdf15286c2690fd307629c5d
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 8 17:50:43 2011 -0800

    Remove RawFilter from xsetwacom
    
    With support for the option completely removed from the driver,
    remove it from xsetwacom as well. Also modify the deprecation
    warning to handle cases like this where we don't want a replacement.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ca418548e8c0114df5c7830ae6e4dc28bf38caf4
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 8 17:50:42 2011 -0800

    Remove RawFilter option from driver
    
    This option was mostly removed from the driver at some point in
    the past, with only these vestigal lines remaining.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7861dc281307d2a8727a99c31009af8ede144479
Author: Jason Gerecke <killertofu@gmail.com>
Date:   Tue Mar 8 08:53:44 2011 -0800

    Fix minor doc style inconsistencies
    
    Add/move periods and whitespace, make defaults consistent, and clarify
    where necessary.
    
    Signed-off-by: Jason Gerecke <killertofu@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3282e954f209683ee2026d72b2adfbf1d4c48cb0
Author: Andrzej Pronobis <a.pronobis@gmail.com>
Date:   Mon Mar 7 12:42:01 2011 -0800

    Decide scroll direction according to tablet orientation
    
    Signed-off-by: Andrzej Pronobis <a.pronobis@gmail.com>
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fc41fb63dd883fc29236af535b22a2b347dfe326
Author: David Foley <favux.is@gmail.com>
Date:   Mon Mar 7 12:56:35 2011 -0600

    xsetwacom.man: Add 5 parameters
    
    Add Mode, PressureCurve, Rotate, TabletPCButton, and Threshold.  And other changes.
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit acd8552d83929963d5cc70d6217c5a15da86c6c0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 14:38:31 2011 +1000

    Don't try to update the button mapping if we don't have anything to update.
    
    If keyword parsing failed and we have zero items to update to (but we're not
    trying to reset the property), don't update the button action property.
    
    Reproducer: xsetwacom set "device" Button 1 "blah"
    would print an error about invalid keywords but still update (erase) the
    button mapping property.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit eba6b9416148e5423c5a0c2632d88dbee5589615
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 14:35:54 2011 +1000

    xsetwacom: fix button action unsetting
    
        xsetwacom set <devicename> Button 1
    should unsets the key action for button 1 (back to button mapping)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8ed4e95e8e65f569a3639959331f0a95b0917f11
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 14:29:21 2011 +1000

    xsetwacom: update a comment  for new button map arguments.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 22bc3028effbdc79d426c0b3dcf586734d4c7532
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 14:21:22 2011 +1000

    xsetwacom: don't re-use argc, add new var "unset_prop"
    
    No functional change, making the code more readable.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit fe07179e4976cdcc530bd2dd3cd482a65a3fd43d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 14:16:55 2011 +1000

    xsetwacom: print error if an unknown keyword is given.
    
    xsetwacom set "device" Button 1 "Ctrl Z" cannot be parsed by xsetwacom,
    leading to a nonfunctioning button without the user realising why. Print an
    error and complain if the keyword is unknown/invalid.
    
    Bug 3054502
    https://sourceforge.net/tracker/?func=detail&atid=525124&aid=3054502&group_id=69596
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit c4007437dcd7b24d949b80fb49e5e8e0699b4201
Merge: a8c95a7 abb4144
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 7 13:11:56 2011 +1000

    Merge branch 'suppress-cleanup'

commit abb4144f6ec125fa37fb6cd1f3eb0c4616367359
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 09:37:13 2011 +1000

    Don't hardcode the rotation range for cursor RZ, use defines instead.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 379be28b51d782c18a2f8ea3b7d59b08329ebbc0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 09:13:28 2011 +1000

    Fix typo for max axis range on the cursor tool.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 859d325be9fc303b78ee4b2fde7fd6ca18888b4d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 4 09:05:09 2011 +1000

    Fix indentation in wcmTilt2R.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 5ca0e09f9058e47d2a2ff1c5474bc1b5aef92c14
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 14:04:39 2011 +1000

    test: remove miPointer wrappers, unneded.
    
    Obsolete with a9fe6a0337183c653ede6b5724612a138b022fb9
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit aa96977dc7ff0b44b7d1dcb5bf524c339d4820e5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 14:01:21 2011 +1000

    test: add tests for wcmCheckSuppress.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 1982daf6b13685cc6568a53b85d62089405963a9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 13:40:08 2011 +1000

    Rewrite wcmCheckSuppress
    
    Instead of returning rather ambiguous 0, 1 and 2, return enums with readable
    descriptions.
    
    No functional changes, other than that we now skip a few tests in
    wcmCheckSuppress if we already have the result.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit a8c95a7975ffa16779cced264062bc64b8631095
Author: David Foley <favux.is@gmail.com>
Date:   Fri Mar 4 12:50:39 2011 -0600

    conf: Add Fujitsu ISDV4 device ID FUJ02e9 to matches
    
    Signed-off-by: David Foley <favux.is@gmail.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 89db1ede87db655b57fb2234194f1c26993ef166
Author: David Foley <favux.is@gmail.com>
Date:   Fri Mar 4 13:28:24 2011 -0600

    wcmUSB.c: Update BambooPT identifier comment
    
    Change 0xDB from CTH-661 to CTH-661/L.
    
    Reported-by: Pander <pander@users.sourceforge.net>
    Signed-off-by: David Foley <favux.is@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e79f7a730cedee93db363c20ddddc9e90b41ef3b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 12:02:27 2011 +1000

    Swap an error message "likely to crash" for one not likely to do so
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 0250ecbc798b47821ed81e87ab852b6cc342efe1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 11:54:18 2011 +1000

    Remove now-obsolete condition.
    
    With the removal of the tool areas, this check became obsolete.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit fe46ffdd55f877e0750017285724181b3ddf4a4c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 11:53:36 2011 +1000

    Document findTool()
    
    And rename tooldef to tooldefault, I always get confused by that.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 07964dc148767f78fee691981935f9450a1981bf
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 11:50:50 2011 +1000

    Document is/set_absolute
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 69d3e9387105e0a92cae95f6f81a62e868506c06
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 15:52:56 2011 +1000

    Add a fixme about tool handling.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 751976d32f756197cc7254ae85956eebdf7e8e47
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 14:32:38 2011 +1000

    Keep an enabled flag in the tool to avoid racy startup.
    
    There is a small time window where a device may try to send an event even
    though it is not fully setup to send events yet, causing a server crash.
    
    This window opens when the tool is added to the list of devices in
    wcmParseOptions() and closes with the server calling xf86ActivateDevice().
    If an event for a dependent device is processed during that time, the tool
    will be available but the device pointer is still invalid.
    
    Crash can be reproduced by putting a breakpoint after wcmParseOptions() for
    the eraser, then generating events with the eraser. These will cause the
    tool to dereference tool->device->dev, which is uninitialized.
    
    Work around this with a simple "enabled" flag that is set whenever the tool
    is actually enabled.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 94a8eabadd062de6ceed8563089b863d887f8770
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 11:29:19 2011 +1000

    Switch to a WorkProc for device hotplugging.
    
    The current approach to hotplugging is to call NIDR directly from the parent
    device's PreInit. This causes a nested device layout as the dependent
    devices are initialised fully before the parent device is initialised.
    
    Switch to a WorkProc instead. Copy the necessary information to create a new
    device later and tell the server to call the actual hotplug function when it
    has time.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 490e345f9d85a73263e96ba0b2918a9a2ca913ad
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 15:27:20 2011 +1000

    Don't manually UnInit the devices for ABI 12
    
    One of the changes going into ABI 12 were that the server calls Uninit even
    on driver-hotplugged devices.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 66466dcf8bbe4c633c006863b30d8d022c575842
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 2 15:16:15 2011 -0800

    Don't discard the first 2 USB events
    
    It was an issue with older kernels. This driver only supports
    kernels 2.6.26 and later. No need to do that any more.
    
    There is a special case that this code may have helped though.
    If tool is on the tablet while driver started, waiting for more
    events before processing them would fill some otherwise filtered
    events from the kernel. Even for this case, the solution should
    be added inside wcmUSB.c, instead of here.
    
    We'll work on that in wcmUSB.c later. Just for the record. The
    perfect solution would be to retrieve all events from the kernel
    if important events, such as tool type, serial number, etc, are
    missing. This would require quite some changes in wcmUSB.c. And,
    the challenge is that linux-input doesn't provide the means for
    us to retrieve all of the events that posted from the kernel. At
    least, we can not retrieve serial number and MT events yet.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 438da502c84e7742acb31e433e42efd5bd003581
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Wed Mar 2 15:16:49 2011 -0800

    Set ISDV4 to PROTOCOL_GENERIC in isdv4ProbeKeys
    
    isdv4ProbeKeys is the place we set all tool types and other keys.
    Reset the ProtocolLevel to PROTOCOL_GENERIC here as well.
    Otherwise, it would be overwrote by the default.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 22e4410cb3de0ac6b6e2275bd8b8bcc0f2cf7b5a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 3 10:05:55 2011 +1000

    test: fix typos and copy/paste effects.
    
    Misplaced closing parens, then copy/pasted everywhere.
    Introduced in 1d9a055bc8e95f20458d7da5b77967f2e53b7d6f
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5c06d9584e1f231bea47aaf1dd33e0502dee34be
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 2 10:40:44 2011 +1000

    test: add license header
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit b80876c01ce62baa63c2563aeef399ffea73f588
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 2 10:39:57 2011 +1000

    test: add note that we can't test static variables here.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit 1d9a055bc8e95f20458d7da5b77967f2e53b7d6f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 2 10:03:31 2011 +1000

    test: add ifdefs to allow running tests against 1.7
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>

commit 9d227cd0bd985e7dcb7923974361145ba1d78713
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 2 10:34:36 2011 +1000

    Move VCOPY storage out of the function.
    
    Not 100% sure why this is needed but it looks like the returned address is
    invalid, causing memory corruption. Simply moving the variable into a global
    scope fixes this issue.
    
    Fixes crash with server 1.7.
    
    Reported-by: Vu Ngoc San <san.vu-ngoc@laposte.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit a113f790fe19b0d30b672eb051a3215880df5d3e
Author: Timo Aaltonen <tjaalton@ubuntu.com>
Date:   Wed Mar 2 19:09:27 2011 +0200

    xsetwacom.c: Fix a typo preventing Rotate ccw from working
    
    Introduced in ac821ba29a828fb9bb531243d0a226a7fe494504
    
    Signed-off-by: Timo Aaltonen <timo.aaltonen@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9dba8e81e132561732c3bc6c0645a6af44eab2a0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 2 11:47:45 2011 +1000

    Bump to 0.10.99.
    
    New release versioning scheme until we settle on a stable 1.0.
    - 0.x.99 is the version number in-between releases
    - 0.x.99.901 is the first RC
    - 0.x.99.902 is the second RC
    - 0.x+1.0 is next the release
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1f0cfe5dd48eec52c495c5777d20758563318783
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 1 15:05:05 2011 +1000

    test: add basic check that the tool is initialized correctly.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 82e65fc52d497b57dab4bcd008ee64f9f7f08796
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 21 14:07:55 2011 +1000

    Remove now unused overlap checking functions
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 13a12bb852f845ce5588f1e7dcda18cd2c21cb59
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 21 13:52:08 2011 +1000

    Purge toolarea from device rec.
    
    Having multiple areas for tool is feature that has gone untested for
    possibly years and it's hard to figure out how to even configure it.
    Purge it.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 751065df9bce662f2e1d74746e1ce6b6cb8c73ce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 21 13:31:15 2011 +1000

    Purge KeepShape option (for now, anyway).
    
    This option is badly broken since the driver has lost the ability to check
    for screen coordinates.
    
    There is a need for this option, but it will have to come back as a
    purely client-configured option (i.e. the client feeds the tablet
    coordinates it should map to).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 24019a07a56fb73132273910d36a036d1c811bb9
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sun Feb 20 22:49:33 2011 -0600

    Make 1 finger tap work based on finger release.
    
    Previous behavior required a double-tap to get a single finger
    tap to work and didn't always work for me.  Its behavior was basically
    tap-and-drag gesture instead of tap-to-click.
    
    Converted to standard touchpad behavior of single tap based on finger
    release.  This is arguely the more important gesture to users.
    
    Removed wcmTouchpadMode since it wasn't needed for simple tap-to-click
    gesture.  If tap-and-drag gets added back and needs a variable, it can
    be added back with a name that has "drag" in it to understand its
    intended usage.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Tested-by: Andrzej Giniewicz <gginiu@gmail.com>
    Acked-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1b30bd68111b7e08fb9ded4302ba556f16253a8a
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Sun Feb 20 19:19:20 2011 -0600

    allow button events while touch is disabled
    
    PROTOCOL_GENERIC devices send "pad" buttons along
    with touchscreen/touchpad events.  Since we are
    emulating "pad" device concept, we need to let
    "pad" events go through when "touch" is disabled.
    
    There seems to be a popular script floating around
    that toggles "touch" device on/off by using
    same devices "pad" buttons.  This patch allows that
    to work again.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 85f4c8ed19f8816d0353ee302cf34f8d11e2b14b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 24 15:28:45 2011 +1000

    Disable KeepShape - it's currently unsupported.
    
    Will come back once it's hooked up properly again.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 577f42d38b66fd84594a6d3f2932a559e68b5751
Author: Bruno Vasselle <bruno.vasselle@laposte.net>
Date:   Fri Feb 25 08:31:21 2011 +1000

    Division by zero in wcmInitArea when KEEP_SHAPE_FLAG is on.
    
    Under some circumstances, wcmInitArea faces a division by zero when trying
    to deal with the "KeepShape" option. The patch disables KeepShape in the
    situation.
    
    Signed-off-by: Bruno Vasselle <bruno.vasselle@laposte.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 240e694d861fe78d516f43f315dbe2b634368131
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Tue Feb 22 17:23:42 2011 -0800

    Retrieve the ABS values through EVIOCGABS only when they are set
    
    We get absinfo.maximum = 0 when the ABS_ is not set in the
    kernel, which is invalid.
    
    This issue was found when I work on the resolution. It applies to
    other ABS_* as well.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ac4f60e378150369f7de64045d80e2f2318e0f63
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 23 09:59:15 2011 +1000

    Update README with a few pointers to website, etc.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>

commit 87d09b7addeee2d7119c81c2f5b415ceebc50931
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Fri Feb 18 11:50:52 2011 -0500

    distcheck fails, xsetwacom.c needs X11_CFLAGS for UNITTESTS
    
    Otherwise it fails to pickup X11/keysym.h and friends.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 957de9b5a32efaf891e5d4ed55207297b060e605
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Fri Feb 18 20:02:12 2011 -0500

    Doxygen: add project name in footer.
    
    The footer was generated by doxygen based on doxygen.conf
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a52277e7f2864493342affb6a4fc6cda74a9d0af
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Fri Feb 18 20:02:11 2011 -0500

    Doxygen: use $PACKAGE_VERSION for the release number
    
    The release number in the main page will always be in sync.
    This will allow archiving the API documentation for each release,
    enabling multiple versions to coexist on the web.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Reviewed-by: Ping Cheng <pinglinux@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e21033fb505734a934bd0400d9ff72e7ec32c326
Author: Favux <favux.is@gmail.com>
Date:   Thu Feb 17 21:09:32 2011 -0600

    xsetwacom.c: Correct typo-spelling
    
    Patch
    
    From 6e682f268416db29cb178f1f7f734b7687081d29 Mon Sep 17 00:00:00 2001
    From: David Foley <favux.is@gmail.com>
    Date: Thu, 17 Feb 2011 20:57:38 -0600
    Subject: [PATCH] xsetwacom.c:  Correct typo/spelling
    
    Reported by: Vu Ngoc San <san.vu-ngoc@laposte.net>
    Signed-off-by: David Foley <favux.is@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 01cf69515fa808c09e2ac80c29d6c638ac8191e7
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Fri Feb 18 12:05:31 2011 -0500

    Doxygen: add description on the main html page
    
    Rather than staring at a blank screen.
    To be completed.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit af58a7af91c00ef4da56c92d143d6bad1475196d
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Fri Feb 18 12:05:30 2011 -0500

    Doxygen: add "getting started" support.
    
    Add Makefile.am and docygen.conf with some customization
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b667dd01313bfbc5c76326de61d7fc659076581c
Merge: 244b5ad 79b3945
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 18 10:07:06 2011 +1000

    Merge branch 'next'

commit 244b5ad8f88d3db52bdde7ade9087b096e5a12ea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 17 14:56:06 2011 +1000

    Require doxygen.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Gaetan Nadon <memsize@videotron.ca>

commit 6ca246bdbb40489490d0b9a72637f997e0629a61
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 17 11:31:36 2011 +1000

    Update release script to deal with SF's shell service
    
    I get auth. failures if I log in too often.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 8cdf444fd1f4004b5a0d237b26ebcd72900338c4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 16 08:45:04 2011 +1000

    wacom 0.10.11
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e1acd61df8bad22864352cd6c9703356d46cb112
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 16 08:41:56 2011 +1000

    test: add more symbols to fake-symbols for ABI < 12
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit f9725353ba6e82b41abc73adb293676248558a08
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 16 08:37:02 2011 +1000

    test: put guards in for changed APIs in earlier server versions.
    
    Addition of const in ABI 12 breaks build if running make check against an
    earlier server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit a7f85d19ec858c9567b08dbe1819019a1a10b83c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 16 08:36:19 2011 +1000

    test: remove _X_RESTRICT_KYWD from definitions
    
    Undefined in earlier server versions, breaks distcheck.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 6e4f971f9dc7d061771712141aff8581ca8ff4ea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 16 08:21:57 2011 +1000

    Remove ABS() macro, just use abs()
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit a9fe6a0337183c653ede6b5724612a138b022fb9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 9 09:50:04 2011 +1000

    Check if the device has been initalised before processing the events.
    
    This is a stopgap solution only. Due to the current hotplugging approach,
    the dependent tools are initialised before the parent device. This leaves us
    with a time window where the parent device does not yet have a DeviceIntPtr
    attached.
    
    If an event from the parent device comes in during this time window, posting
    the event causes segfaults. Fix this for now by checking if there is a
    device attached to it yet.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b6fb68cf4930d20cb91d9fd939587082ee2e2dfd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 9 09:48:48 2011 +1000

    Rename pDev to pInfo where it is an InputInfoPtr.
    
    For consistency with the rest of the code.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 79b3945d3ab3b270e7bd6a7deb8e6b52e0c2b8fa
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 14:12:32 2011 +1000

    xsetwacom: comment convert_specialkeys.
    
    And change a paramter name to be more self-explanatory.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 70e0d864b16c36486e835a79b52699aee5de5a10
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 14:10:10 2011 +1000

    xsetwacom: document is_modifier
    
    And change a parameter name to make the function more self-explanatory.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit f7bbd3a14b796c8d6adef3322cc7a4b19a466c7f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 14:08:11 2011 +1000

    xsetwacom: use single exit path in is_modifier.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit ba20f19bf66b1e79f1aa56be6deb8aac952ff33e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 14:07:23 2011 +1000

    xsetwacom: remove separate modifier list in is_modifier.
    
    Simply parse through the existing modifier list.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 5fedf69d653cfbee9ac393643c4cbe0b23e87e19
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 15:12:49 2011 +1000

    xsetwacom: add test for parameter numbers.
    
    Simple manual check that we remeber to properly deprecate if we ever remove
    a parameter again.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit 0b1462aa27bbf3d8653a762fd8e1648b856a76e3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 15:06:26 2011 +1000

    xsetwacom: add test for convert_specialkey
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit f6dc39637056adc6fe503654b9f44f225dc4f6ac
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 14:59:14 2011 +1000

    xsetwacom: hook up to unittests.
    
    Includes simple test for is_modifier().
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit e1b97d153426d8e8712b09806ad0b0bfc517b485
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 14 15:10:50 2011 +1000

    test: fix indentation to be in-line with the rest of the driver
    
    And add the vim tags so this doesn't happen again.
    Sorry.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit c1e18af5794191a5560fb60bd447e05fdafd53cb
Author: Przemo Firszt <przemo@firszt.eu>
Date:   Sun Jan 2 23:06:46 2011 +0000

    Add Super and Hyper as modifiers
    
    Super_L / _R and Hyper_L/_R were missing from the list of modifiers in
    is_modifier function in xsetwacom.c. It was causing some troubles,
    reported as bug 3140393
    
    Signed-off-by: Przemo Firszt <przemo@firszt.eu>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f856de8b9d4dd721d3a189665045ea0b9ac6f126
Author: Chris Bagwell <chris@cnpbagwell.com>
Date:   Wed Feb 9 12:38:00 2011 -0600

    remove unsupported "Speed" option from man page.
    
    Use xinput's "Device Accel Constant Deceleration" for similar feature.
    
    Signed-off-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0f9a1371a2498e0c74ecdf381d28b5bc3adfaa25
Merge: 32babb0 b49d98a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 10 13:12:47 2011 +1000

    Merge branch 'test-suite'

commit 32babb0c89db59a73890ae5a989b65fd128486f5
Merge: bf9ba5f 868d768
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 9 09:51:54 2011 +1000

    Merge branch 'xsetwacom-cleanup'

commit 868d768e91444ae47cca3ab1902e0161920011ea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 8 13:31:48 2011 +1000

    xsetwacom: print warnings for deprecated parameters.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Ping Cheng <pinglinux@gmail.com>

commit bf9ba5f101a28db64973b1933debed381ee1654e
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Feb 3 21:12:10 2011 -0800

    Process USB 1FGT data through BTN_TOUCH
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 80b9d51819c48a10914be165720d2c59c587cf01
Author: Ping Cheng <pinglinux@gmail.com>
Date:   Thu Feb 3 20:59:30 2011 -0800

    Prepare for Tablet PC MT format
    
    We borrowed _TAP_ for 2FGT Tablet PC support when MT protocol was
    not available (before kernel 2.6.30 was released). MT support in
    the kernel is getting stable now. To move Tablet PC to MT format,
    we face two issues:
    
    1. USB Tablet PC 1FGT devices will not emit BTN_TOOL_FINGER event
    since it is a touchscreen device.
    
    2. Serial Tablet PC 2FGT devices do not emit BTN_TOOL_DOUBLETAP
    event since they are not touchpads.
    
    This patch add those keys back to the supported key array so we
    can retrieve the proper keys when we need to decide the features
    that are associated with the device.
    
    Changes to v1:
    
    1. Replace usbGenericTPCQuirks with usbGenericTouchscreenQuirks
    2. Remove USB from the second item above
    
    as suggested by Chris Bagwell.
    
    Signed-off-by: Ping Cheng <pinglinux@gmail.com>
    Acked-by: Chris Bagwell <chris@cnpbagwell.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 36520328f4b42f2556a8472a66ea2e9986a59ebd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 8 14:57:00 2011 +1000

    man: note that the threshold applies to the normalized pressure range.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit e5540823b1b70b4e0a5f91116e7f75d564a40d78
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 8 14:36:26 2011 +1000

    Rename transPressureCurve to applyPressureCurve.
    
    More self-explanatory name because with recent refacturing, that's all we're
    doing here.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit f1059805593f52080854d3c3e8a85fb2633f90b6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 8 14:34:57 2011 +1000

    Return converted pressure, don't set it directly.
    
    Allows for constification of the parameter in transPressureCurve().
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 61f1a2ae93a7e801302a27b7ca58ef9806bdec78
